var rsslist;
var atomlist;
var opmllist;
var foundCount;

//**************************************************************************
function searchload() {

	opener.addEventListener("close", doSearchOK, true);

	rsslist = document.getElementById("rsslist");
	atomlist = document.getElementById("atomlist");
	opmllist = document.getElementById("opmllist");
	foundCount = 0;

	var mediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
	var content = mediator.getMostRecentWindow("navigator:browser").document.getElementById("content");
	var contentDoc = content.contentDocument;
	document.getElementById("urllabel").value = contentDoc.documentURI;
	if (contentDoc.contentType.indexOf("html") != -1) {
		procdoc(contentDoc);
		procframes(contentDoc);
	}
	document.getElementById("found").value = foundCount + " " + opener.strbundle.getString("found");
}

//**************************************************************************
function procframes(contentDoc) {
	var frames = contentDoc.getElementsByTagName("frame");
	if (frames.length > 0) {
		for (var n = 0; n < frames.length; n ++) {
			procdoc(frames[n].contentDocument);
			procframes(frames[n].contentDocument);
		}
	}
	frames = contentDoc.getElementsByTagName("iframe");
	if (frames.length > 0) {
		for (var n = 0; n < frames.length; n ++) {
			procdoc(frames[n].contentDocument);
			procframes(frames[n].contentDocument);
		}
	}
}

//**************************************************************************
function procdoc(contentDoc) {
	var links = contentDoc.getElementsByTagName("link");
	if (links.length > 0) {
		procfound(links);
	}
	links = contentDoc.getElementsByTagName("a");
	if (links.length > 0) {
		procfound(links);
	}
}

//**************************************************************************
function procfound(elements) {
	for (var n = 0; n < elements.length; n++) {
		var type = elements[n].type;
		var title = elements[n].title;
		if (title == "") {
			title = "No Title";
		}
		var item;
		if (type == "application/rss+xml") {
			foundCount++;
			item = rsslist.appendItem(title, elements[n].href);
			item.setAttribute("style", "color: darkred; font-weight: bold;");
		} else if (type == "application/atom+xml") {
			foundCount++;
			item = atomlist.appendItem(title, elements[n].href);
			item.setAttribute("style", "color: darkred; font-weight: bold;");
		} else if (type == "text/x-opml") {
			foundCount++;
			item = opmllist.appendItem(title, elements[n].href);
			item.setAttribute("style", "color: darkred; font-weight: bold;");
		}
	}
}

//**************************************************************************
function addOPML() {
	if (opmllist.selectedIndex != -1) {
		opener.opmlImpURL(opmllist.selectedItem.value);
	}
}

//**************************************************************************
function searchunload() {
	opener.removeEventListener("close", doSearchOK, true);
}

//**************************************************************************
function doSearchOK() {
	document.getElementById("search").acceptDialog();
}

//**************************************************************************
var rssDNDObserver = {
	onDragStart: function (event, tdata, action) {
		if (rsslist.selectedIndex != -1) {
			var txt = rsslist.selectedItem.value;
			tdata.data = new TransferData();
			tdata.data.addDataForFlavour("text/x-moz-url", txt);
		}
	}
};

//**************************************************************************
var atomDNDObserver = {
	onDragStart: function (event, tdata, action) {
		if (atomlist.selectedIndex != -1) {
			var txt = atomlist.selectedItem.value;
			tdata.data = new TransferData();
			tdata.data.addDataForFlavour("text/x-moz-url", txt);
		}
	}
};

