var xmlReqArray;
var readtmpstatement;
var lastreadstatement;
var mDBConn;

//**************************************************************************
function abortfeedread() {
	opener.removeEventListener("abortfeedread", abortfeedread, true);
	for (var n = 0; n < xmlReqArray.length; n++) {
		var reqobj = xmlReqArray[n];
		reqobj = reqobj.QueryInterface(Components.interfaces.nsIXMLHttpRequest);
		reqobj.abort();
	}
	readtmpstatement.reset();
	readtmpstatement.finalize();
	lastreadstatement.reset();
	lastreadstatement.finalize();
	mDBConn.close();
	busyOff();
}

//**************************************************************************
function itemReader(array) {

	this.file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	this.file.append("wizzrss");
	this.file.append("wizzrss.sqlite");
	this.storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	mDBConn = this.storageService.openDatabase(this.file);
	readtmpstatement = mDBConn.createStatement("INSERT INTO readtmp (recid, feedurl, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate, addeddate, status) VALUES (NULL, ?1, ?2, ?3, ?4, ?5, ?6, ?7, ?8, 0)");
	lastreadstatement = mDBConn.createStatement("INSERT INTO lastread (feedurl, feedname, feedsubtitle) VALUES (?1, ?2, ?3)");

	this.array = array;

	this.invalidxmlmsg = opener.strbundle.getString("invalidxmlmsg");
	this.noitemsxmlmsg = opener.strbundle.getString("noitemsxmlmsg");
	this.nodescription = opener.strbundle.getString("nodescription");
	this.filternotfound = opener.strbundle.getString("filternotfound");
	this.notitle = opener.strbundle.getString("notitle");
	this.showReadItems = readPref("WizzRSSShowRead", true, 2);
	this.sortItems = readPref("WizzRSSSortItems", false, 2);
	this.sortedBy = readPref("WizzRSSSortedBy", "Alpha", 1);
	this.useContent = readPref("WizzRSSUseContent", false, 2);
	this.addedDate = new Date().getTime();

	this.feedsToRead = array.length;
	this.feedsRead = 0;
	xmlReqArray = new Array();
}

//**************************************************************************
itemReader.prototype = {

	processFeeds: function processFeeds() {
		busyOn();
		opener.addEventListener("abortfeedread", abortfeedread, true);
		this.deleteLastRead();
		for (var n = 0; n < this.array.length; n++) {
			try {
				var xmlReq = new XMLHttpRequest();
				xmlReqArray.push(xmlReq);
				xmlReq.setCallback(this);
				xmlReq.open("GET", this.array[n][0], true);
				xmlReq.onload = this.onFeedLoad;
				xmlReq.onerror = this.onFeedError;
				xmlReq.setRequestHeader("User-Agent", "Wizz RSS News Reader");
				xmlReq.overrideMimeType("application/xml");
				xmlReq.send(null);
			} catch (e) {
				this.checkBusy();
				displayAlert(this.invalidxmlmsg);
			}
		}
	},

	// This is part of the redirect fix
	processRedirect: function processRedirect(URL) {
		try {
			var xmlReq = new XMLHttpRequest();
			xmlReqArray.push(xmlReq);
			xmlReq.setCallback(this);
			xmlReq.open("GET", URL, true);
			xmlReq.onload = this.onFeedLoad;
			xmlReq.onerror = this.onFeedError;
			xmlReq.setRequestHeader("User-Agent", "Wizz RSS News Reader");
			xmlReq.overrideMimeType("application/xml");
			xmlReq.send(null);
		} catch (e) {
			this.checkBusy();
			displayAlert(this.invalidxmlmsg);
		}
	},

	checkBusy: function checkBusy() {
		this.feedsRead++;
		if (this.feedsToRead == this.feedsRead) {
			opener.removeEventListener("abortfeedread", abortfeedread, true);
			this.updateaggregated();
			busyOff();
		}
	},

	clearList: function clearList() {
		var listcount = wizzitemlist.getRowCount();
		wizzitemlist.scrollToIndex(0);
		while (listcount != 0) {
			listcount--;
			wizzitemlist.removeItemAt(listcount);
		}
	},

	onFeedError: function onFeedError(event) {
		var callback = event.target.getCallback();
		callback.checkBusy();
		displayAlert(callback.invalidxmlmsg);
	},

	onFeedLoad: function onFeedLoad(event) {

		var callback = event.target.getCallback();

		// This is part of the redirect fix
		var location = event.target.getResponseHeader("location");
		if (location) {
			callback.changeFeedUrl(event.target.channel.originalURI.spec, location);
			callback.processRedirect(location);
			return;
		}

		var data = event.target.responseText;

		if (data.indexOf("<media:group") != -1) {
			data = cleanFeed(event.target.responseXML);
		}

		if (data.length) {
			var parser = Components.classes["@mozilla.org/feed-processor;1"].createInstance(Components.interfaces.nsIFeedProcessor);
			try {
				parser.listener = callback;
				parser.parseFromString(data, event.target.channel.originalURI);
			} catch(e) {
				displayAlert(callback.invalidxmlmsg);
			}
		} else {
			displayAlert(callback.invalidxmlmsg);
		}
	},

	handleResult: function handleResult(result) {
		if (result) {
			var feed = result.doc;
			if (feed) {
				var feedname = this.getFeedName(result.uri.spec);
				feed.QueryInterface(Components.interfaces.nsIFeed);
				if (feed.items.length) {
					mDBConn.beginTransaction();
					if (feedname == null) {
						if (feed.title) {
							if(feed.title.text != null && trim(feed.title.text).length > 0) {
								feedname = feed.title.text;
							} else {
								feedname = this.notitle;
							}
						} else {
							feedname = this.notitle;
						}
					}
					var feedsubtitle = "";
					if (feed.subtitle) {
						feedsubtitle = feed.subtitle.text;
					}
					if (!feedsubtitle) {
						feedsubtitle = this.nodescription;
					}
					var feedlink = "none";
					if (feed.link) {
						feedlink = feed.link.spec;
					}
					this.writelastread(result.uri.spec, feedname, feedsubtitle + "-;-" + feedlink);
					this.updateAnnotations(result.uri.spec, feedlink, feedsubtitle);
					var itemArray = feed.items;
					for (var n = 0; n < itemArray.length; n++) {
						var entry = itemArray.queryElementAt(n, Components.interfaces.nsIFeedEntry);

						var itemTitle = this.notitle;
						var itemLink = "";
						var itemEnclosure = "";
						var itemSummary = "";
						var itemContent = "";
						var itemUpdated = "";
						var itemPublished = "";
						if (entry.title) {
							if (entry.title.text != null && trim(entry.title.text).length > 0) {
								itemTitle = entry.title.text;
							}
						}
						if (entry.link) {
							itemLink = entry.link.spec;
						}
						
						if (entry.enclosures) {
							var enc = entry.enclosures.queryElementAt(0, Components.interfaces.nsIWritablePropertyBag2);
							if (enc.hasKey("url")) {
            						itemEnclosure = enc.get("url");
							}
						}

						if (entry.summary) {
							if (entry.summary.text != null && trim(entry.summary.text).length > 0) {
								itemSummary = entry.summary.text;
							}
						}
						if (entry.content) {
							if (entry.content.text != null && trim(entry.content.text).length > 0) {
								itemContent = entry.content.text;
							}
						}
						if (entry.updated) {
							itemUpdated = entry.updated;
						}
						if (entry.published) {
							itemPublished = entry.published;
						}

						var itemDate = "";
						if (itemPublished != "") {
							itemDate = itemPublished;
						} else if (itemUpdated != "") {
							itemDate = itemUpdated;
						}

						if (itemDate.length > 0 && itemDate != "Invalid Date") {
							itemDate = new Date(itemDate).getTime();
						} else {
							itemDate = this.addedDate;
						}
						this.writedata(result.uri.spec, itemTitle, itemLink, itemEnclosure, itemSummary, itemContent, itemDate);
					}
					mDBConn.commitTransaction();
				} else {
					displayAlert(this.noitemsxmlmsg);
				}
			} else {
				displayAlert(this.invalidxmlmsg);
			}
		} else {
			displayAlert(this.invalidxmlmsg);
		}
		this.checkBusy();
	},

	writedata: function writedata(feedurl, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate) {

		itemtitle = itemtitle.replace(/\t/g, ' ');
		itemtitle = htmlToText(wizzSanitizer.cleanElement(itemtitle));
		itemurl = wizzSanitizer.cleanElement(itemurl);
		itemsummary = wizzSanitizer.cleanElement(itemsummary);
		itemcontent = wizzSanitizer.cleanElement(itemcontent);
		if (enclosureurl.length != 0) {
			enclosureurl = wizzSanitizer.cleanElement(enclosureurl);
		}
		if (itemurl.length == 0 && enclosureurl.length != 0) {
			itemurl = enclosureurl;
		}
		readtmpstatement.bindStringParameter(0, feedurl);
		readtmpstatement.bindUTF8StringParameter(1, itemtitle);
		readtmpstatement.bindStringParameter(2, itemurl);
		readtmpstatement.bindStringParameter(3, enclosureurl);
		readtmpstatement.bindUTF8StringParameter(4, itemsummary);
		readtmpstatement.bindUTF8StringParameter(5, itemcontent);
		readtmpstatement.bindInt64Parameter(6, itemdate);
		readtmpstatement.bindInt64Parameter(7, this.addedDate);
		readtmpstatement.execute();
	},

	writelastread: function writelastread(feedurl, feedname, feedsubtitle) {
		lastreadstatement.bindStringParameter(0, feedurl);
		lastreadstatement.bindStringParameter(1, feedname);
		lastreadstatement.bindStringParameter(2, feedsubtitle);
		lastreadstatement.execute();
	},

	deleteLastRead: function deleteLastRead() {
		mDBConn.executeSimpleSQL("DELETE FROM readtmp");
		mDBConn.executeSimpleSQL("DELETE FROM lastread");
	},

	deleteLastData: function deleteLastData() {
		mDBConn.executeSimpleSQL("DELETE FROM aggregated WHERE feedurl IN (SELECT feedurl FROM lastread)");
		mDBConn.executeSimpleSQL("DELETE FROM lastread");
	},

	updateaggregated: function updateaggregated() {
		var retaintime = readPref("WizzRSSRetainDays", 14, 3);
		if (retaintime > 0) {
			retaintime = retaintime * 86400000;
			retaintime = new Date().getTime() - retaintime;
			mDBConn.executeSimpleSQL("DELETE FROM aggregated WHERE addeddate < " + retaintime + " AND itemurl NOT IN (SELECT itemurl FROM readtmp) AND feedurl IN (SELECT feedurl FROM lastread)");
		} else {
			mDBConn.executeSimpleSQL("DELETE FROM aggregated");
		}

		mDBConn.executeSimpleSQL("DELETE FROM readtmp WHERE itemurl IN (SELECT DISTINCT readtmp.itemurl FROM readtmp, aggregated WHERE readtmp.itemurl = aggregated.itemurl AND readtmp.feedurl = aggregated.feedurl AND readtmp.itemtitle = aggregated.itemtitle)");
		mDBConn.executeSimpleSQL("INSERT INTO aggregated SELECT recid, feedurl, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate, addeddate, status FROM readtmp");
		this.addListItems(null);
	},

	addListItems: function addListItems(filterstring) {

		var feedurls = new Array();
		var statement = mDBConn.createStatement("SELECT * FROM lastread");
		while (statement.executeStep()) {
			var splitdata = statement.getString(2).split("-;-");
			feedurls.push(new Array(statement.getString(0), statement.getString(1), splitdata[0], splitdata[1]));
		}
		statement.reset();
		statement.finalize();

		if (feedurls.length > 0) {
			this.clearList();

			mDBConn.executeSimpleSQL("DELETE FROM results");
			
			for (var i = 0; i < feedurls.length; i++) {

				var sqlstring = "INSERT INTO results SELECT * FROM aggregated"
				sqlstring += " WHERE feedurl = '" + feedurls[i][0] + "'";

				if (filterstring != null) {
					var filter = filterstring.split(" ");
					for (var n = 0; n < filter.length; n++) {
						if (n == 0) {
							sqlstring += " AND (";
						} else {
							sqlstring += " OR ";
						}
						var critstring = filter[n];
						critstring = critstring.replace(/&/g, ' ');
						sqlstring += "itemtitle LIKE '%" + critstring + "%' OR itemsummary LIKE '%" + critstring + "%'";
					}
				}

				if (filterstring != null) {
					sqlstring += ")";
				}

				if (this.sortItems) {
					if (this.sortedBy == "Alpha") {
						sqlstring += " ORDER BY itemtitle";	
					} else {
						sqlstring += " ORDER BY itemdate DESC";
					}
				} else {
					sqlstring += " ORDER BY addeddate DESC";
				}

				var readcount = readPref("WizzRSSItemLimit", 0, 3);

				if (readcount > 0) {
					sqlstring += " LIMIT 0, " + readcount;
				}
				mDBConn.executeSimpleSQL(sqlstring);
			}

			var newitem;
			var readicon = "chrome://wizzrss/skin/" + readPref("WizzRSSReadDot", "Red", 1) + ".gif";
			var itemHistFlag;
			var encHistFlag;
			var feedURL = "";
			var foundflag = false;

			sqlstring = "SELECT feedurl, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate FROM results"

			if (this.sortItems) {
				if (this.sortedBy == "Alpha") {
					sqlstring += " ORDER BY feedurl, itemtitle";	
				} else {
					sqlstring += " ORDER BY feedurl, itemdate DESC";
				}
			} else {
				sqlstring += " ORDER BY feedurl, addeddate DESC";
			}

			statement = mDBConn.createStatement(sqlstring);
			while (statement.executeStep()) {
				foundflag = true;
				var feedurl = statement.getString(0);
				if (feedURL != feedurl) {
					feedURL = feedurl;
					var titleText = "";
					var titleSummary = "";
					var homeURL = "";
					for (var i=0; i<feedurls.length; i++) {
						if (feedurls[i][0] == feedurl) {
							titleText = feedurls[i][1];
							titleSummary = feedurls[i][2];
							homeURL = feedurls[i][3];
							break;
						}
					}
					var title = wizzitemlist.appendItem(titleText, "Title-;-" + titleSummary + "-;-" + homeURL);
					title.setAttribute("style", "color: darkred; font-weight: bold;");
				}
				var itemTitle = statement.getString(1);
				var itemURL = statement.getString(2);
				itemURL = itemURL.replace(/&amp;/g, "&");
				var enclosureURL = statement.getString(3);
				enclosureURL = enclosureURL.replace(/&amp;/g, "&");
				var itemSummary = statement.getString(4);
				var itemContent = statement.getString(5);
				var itemDate = new Date(statement.getInt64(6)).toUTCString();
				itemHistFlag = wizzHistory.checkHist(itemURL);
				encHistFlag = wizzHistory.checkHist(enclosureURL);
					if (((!this.showReadItems && !itemHistFlag) || this.showReadItems) || ((!this.showReadItems && !encHistFlag) || this.showReadItems)) {
						var itemText = "";
						if (this.useContent && itemContent.length > 0) {
						itemText = itemContent;
					} else {
						if (itemSummary.length > 0) {
							itemText = itemSummary;
						} else {
							itemText = this.nodescription;
						}
					}
					newitem = wizzitemlist.appendItem(itemTitle, itemURL + "-;-" + itemText + "-;-" + enclosureURL + "-;-" + itemDate);
					newitem.setAttribute("class", "listitem-iconic");
					if (enclosureURL == "") {
						if (itemHistFlag) {
							newitem.setAttribute("image", readicon);
						} else {
							newitem.setAttribute("image", "chrome://wizzrss/skin/Unread.gif");
						}
					} else {
						newitem.style.fontStyle = "italic";
						if (itemHistFlag && encHistFlag) {
							newitem.setAttribute("image", readicon);
						} else if (!itemHistFlag && !encHistFlag) {
							newitem.setAttribute("image", "chrome://wizzrss/skin/Unread.gif");
						} else {
							newitem.setAttribute("image", "chrome://wizzrss/skin/PartRead.gif");
						}
					}
				}
			}
			statement.reset();
			statement.finalize();
			if (filterstring != null && !foundflag) {
				alert(this.filternotfound);
				this.addListItems(null);
			}

			if (this.array[0] != null && readPref("WizzRSSPreviewMode", false, 2)) {
				wizzitemlist.selectItem(wizzitemlist.getItemAtIndex(0));
				doPreview(null);
			}

		}
		readtmpstatement.reset();
		readtmpstatement.finalize();
		lastreadstatement.reset();
		lastreadstatement.finalize();
		mDBConn.close();

	},

	getFeedName: function getFeedName(URL) {
		var retval = this.notitle;
		for (var x = 0; x < this.array.length; x++) {
			if (this.array[x][0] == URL) {
				retval = this.array[x][1];
				break;
			}
		}
		return retval;
	},

	// This is part of the redirect fix
	changeFeedUrl: function changeFeedUrl(oldURL, newURL) {
		for (var x = 0; x < this.array.length; x++) {
			if (this.array[x][0] == oldURL) {
				this.array[x][0] = newURL;
				break;
			}
		}
	},

	getNode: function getNodeId(URL) {
		var retval = null;
		for (var x = 0; x < this.array.length; x++) {
			if (this.array[x][0] == URL && this.array[x][2] != null) {
				retval = this.array[x][2];
				this.array[x][2] = null;
				break;
			}
		}
		return retval;
	},

	updateAnnotations: function updateAnnotations(URL, homeurl, subtitle) {
		var nodeId = this.getNode(URL);
		if (nodeId) {
			PlacesUtils.annotations.setItemAnnotation(nodeId, "bookmarkProperties/feedhome", homeurl, 3, PlacesUtils.annotations.EXPIRE_NEVER);
			PlacesUtils.annotations.setItemAnnotation(nodeId, "bookmarkProperties/description", subtitle, 3, PlacesUtils.annotations.EXPIRE_NEVER);
			PlacesUtils.annotations.setItemAnnotation(nodeId, "bookmarkProperties/feedstatus", "Read", 3, PlacesUtils.annotations.EXPIRE_NEVER);
		}
	}
};

XMLHttpRequest.prototype.Callback = null;

XMLHttpRequest.prototype.setCallback = function setCallback(callback) {
	XMLHttpRequest.prototype.Callback = callback;
}

XMLHttpRequest.prototype.getCallback = function getCallback() {
	return XMLHttpRequest.prototype.Callback;
}