var markFlag;
var markCatFlag = false;
var channelsToMark = 0;
var channelsMarked = 0;
var livemarkService = Cc["@mozilla.org/browser/livemark-service;2"].getService(Ci.nsILivemarkService);

//**************************************************************************
function markStuff(val) {

	var node = cattree.controller._view.selectedNode;
	var isLivemark = PlacesUtils.nodeIsLivemarkContainer(node);
	if (node.type == node.RESULT_TYPE_FOLDER && !isLivemark) {
		markCatFlag = true;
		markCat(val, node);
	} else if (node.type == node.RESULT_TYPE_URI || isLivemark) {
		if (val == 1) {
			PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/feedstatus", "Read", 3, PlacesUtils.annotations.EXPIRE_NEVER);
		} else {
			PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/feedstatus", "Unread", 3, PlacesUtils.annotations.EXPIRE_NEVER);
		}
		markCatFlag = false;
		markdbstuff.init();
		var url;
		if (isLivemark) {
			url = livemarkService.getFeedURI(node.itemId).spec;
		} else {
			url = node.uri;
		}
		markdbstuff.markdbitems(url, val);
		markdbstuff.cleanup();
		markChannel(null, val, node);
	}
}

//**************************************************************************
function markCat(val, node) {

	// 1 = mark
	// 2 = unmark

	var folder = node.QueryInterface(Components.interfaces.nsINavHistoryContainerResultNode);
	var currentState = folder.containerOpen;

	if (!currentState) {
		folder.containerOpen = true;
	}

	var array = new Array();
	for (var i = 0; i < folder.childCount; i ++) {
		var foldernode = folder.getChild(i);
		var isLivemark = PlacesUtils.nodeIsLivemarkContainer(foldernode);
		if (foldernode.type == foldernode.RESULT_TYPE_URI || isLivemark) {
			var url;
			if (isLivemark) {
				url = livemarkService.getFeedURI(foldernode.itemId).spec;
			} else {
				url = trim(foldernode.uri);
			}
			if (url.length > 0) {
				if (val == 1) {
					PlacesUtils.annotations.setItemAnnotation(foldernode.itemId, "bookmarkProperties/feedstatus", "Read", 3, PlacesUtils.annotations.EXPIRE_NEVER);
				} else {
					PlacesUtils.annotations.setItemAnnotation(foldernode.itemId, "bookmarkProperties/feedstatus", "Unread", 3, PlacesUtils.annotations.EXPIRE_NEVER);
				}
				array.push(url);
			}
		}
	}

	folder.containerOpen = currentState;

	if (array.length != 0 ) {
		busyOn();
		markFlag = val;
		channelsToMark = array.length;
		channelsMarked = 0;
		markdbstuff.init();
		for (var n = 0; n < array.length; n++) {
			markdbstuff.markdbitems(array[n], markFlag);
			markChannel(array[n], markFlag, null);
		}
		markdbstuff.cleanup();
	}
}

//**************************************************************************
function markChannel(url, val, node) {
	markFlag = val;
	busyOn();
	if (url == null) {
		channelsToMark = 1;
		channelsMarked = 0;
		var url;
		if (PlacesUtils.nodeIsLivemarkContainer(node)) {
			url = livemarkService.getFeedURI(node.itemId).spec;
		} else {
			url = trim(node.uri);
		}
	}
	var xmlReq = new XMLHttpRequest();
	xmlReq.open("GET", url, true);
	xmlReq.onload = markChannelOnload;
	xmlReq.onerror = markErrorHandler;
	xmlReq.setRequestHeader("User-Agent", "Wizz RSS News Reader");
	xmlReq.overrideMimeType("application/xml");
	xmlReq.send(null);
}

//**************************************************************************
function markErrorHandler(event) {
	channelsMarked++;
	if (channelsToMark == channelsMarked) {
		busyOff();
	}
}

//**************************************************************************
function markChannelOnload(event) {

	// This is part of the redirect fix
	try {
		var location = event.target.getResponseHeader("location");
	} catch (e) {}
	if (location) {
		markChannel(location, markFlag, null);
		return;
	}

	channelsMarked++;
	var data = event.target.responseText;

	if (data.indexOf("<media:group") != -1) {
		data = cleanFeed(event.target.responseXML);
	}

	if (data.length) {

		var parser = Components.classes["@mozilla.org/feed-processor;1"].createInstance(Components.interfaces.nsIFeedProcessor);
		try {
			parser.listener = new markChannelResultHandler();
			parser.parseFromString(data, event.target.channel.originalURI);
		} catch(e) {}
	}
}

//**************************************************************************
function markChannelResultHandler() {
}

markChannelResultHandler.prototype = {
	handleResult: function(result) {
		if (result) {
			var feed = result.doc;
			if (feed) {
				feed.QueryInterface(Components.interfaces.nsIFeed);
				if (feed.items.length) {
					var itemArray = feed.items;
					for (var n = 0; n < itemArray.length; n++) {
						var entry = itemArray.queryElementAt(n, Components.interfaces.nsIFeedEntry);
						if (entry.link) {
							itemLink = entry.link.spec;
							if (markFlag == 1) {
								wizzHistory.addHist(itemLink);
							} else {
								wizzHistory.remHist(itemLink);
							}
						}

						if (entry.enclosures) {
							var enc = entry.enclosures.queryElementAt(0, Components.interfaces.nsIWritablePropertyBag2);
							if (enc.hasKey("url")) {
            						var encLink = enc.get("url");
								if (markFlag == 1) {
									wizzHistory.addHist(encLink);
								} else {
									wizzHistory.remHist(encLink);
								}
							}
						}
					}
				}
			}
		}
		if (!markCatFlag) {
			opener.fireWizzEvent("updateind");
			busyOff();
		} else {
			if (channelsMarked == channelsToMark) {
				opener.fireWizzEvent("updateind");
				busyOff();
			}
		}
	}
}

//**************************************************************************
function markItems(val) {
	var listcount = itemlist.getRowCount();
	for (var i = 0; i < listcount; i++) {
		markIt(itemlist.getItemAtIndex(i), val);
	}
	opener.fireWizzEvent("updateind");
}

//**************************************************************************
function markItem(val) {
	var values = itemlist.selectedItem.getAttribute("value").split("-;-");
	if (values[0] != "Title") {
		markIt(itemlist.selectedItem, val);
		opener.fireWizzEvent("updateind");	
	} else {
		var index = itemlist.selectedIndex;
		index++;
		values = itemlist.getItemAtIndex(index).getAttribute("value").split("-;-");
		while (values[0] != "Title" && index < itemlist.getRowCount()) {
			markIt(itemlist.getItemAtIndex(index), val);
			index++;
			if (index < itemlist.getRowCount()) {
				values = itemlist.getItemAtIndex(index).getAttribute("value").split("-;-");
			}
		}
		opener.fireWizzEvent("updateind");
	}
}

//**************************************************************************
function markIt(item, val) {
	var values = item.getAttribute("value").split("-;-");
	if (values[0] != "Title") {
		if (val == 1) {
			wizzHistory.addHist(values[0]);
			if (values[2] != "") {
				wizzHistory.addHist(values[2]);
			}
		} else {
			wizzHistory.remHist(values[0]);
			if (values[2] != "") {
				wizzHistory.remHist(values[2]);
			}
		}
	}
}

//**************************************************************************
function markDescItem(val) {
	try {
		var url = itemdesc.contentDocument.getElementById("URL");
		if (val == 1) {
			wizzHistory.addHist(url.value);
		} else {
			wizzHistory.remHist(url.value);
		}
		opener.fireWizzEvent("updateind");
	} catch (e) {}
}

var markdbstuff = {

	markdbitems: function markdbitems(url, val) {
		this.statement.bindStringParameter(0, url);
		while (this.statement.executeStep()) {
			var itemurl = this.statement.getString(0);
			var encurl = this.statement.getString(1);
			if (val == 1) {
				wizzHistory.addHist(itemurl);
				if (encurl) {
					wizzHistory.addHist(encurl);
				}
			} else {
				wizzHistory.remHist(itemurl);
				if (encurl) {
					wizzHistory.remHist(encurl);
				}
			}
		}
		this.statement.reset();
	},

	init: function init() {
		var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		file.append("wizzrss");
		file.append("wizzrss.sqlite");
		var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
		this.mDBConn = storageService.openDatabase(file);
		this.statement = this.mDBConn.createStatement("SELECT itemurl, enclosureurl FROM aggregated WHERE feedurl=?1");
	},

	cleanup: function cleanup() {
		this.statement.finalize();
		this.mDBConn.close();
	}
}