var node;
var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"].getService(Components.interfaces.nsILivemarkService);

//**************************************************************************
function propinit() {
	node = opener.cattree.controller._view.selectedNode;

	var date = getDateAsString(node.dateAdded);
	document.getElementById("propaddeddate").value = date;

	date = getDateAsString(node.lastModified);
	document.getElementById("propmodifieddate").value = date;

	document.getElementById("propname").value = node.title;
	if (node.type == node.RESULT_TYPE_FOLDER && !opener.PlacesUtils.nodeIsLivemarkContainer(node)) {
		document.getElementById("lastread").hidden = "true";
		document.getElementById("readcount").hidden = "true";
		document.getElementById("propurllabel").hidden = "true";
		document.getElementById("propdesclabel").hidden = "true";
		document.getElementById("propdesc").hidden = "true";
		document.getElementById("propurl").hidden = "true";
		document.getElementById("propfeedhomelabel").hidden = "true";
		document.getElementById("homebutton").hidden = "true";
		document.getElementById("propfeedhome").hidden = "true";
		document.getElementById("propwatched").hidden = "true";
		document.getElementById("watchlistaction").hidden = "true";
		document.getElementById("propactionlabel").hidden = "true";
		document.getElementById("validatebutton").hidden = "true";
	} else if (node.type == node.RESULT_TYPE_URI || opener.PlacesUtils.nodeIsLivemarkContainer(node)) {

		if (node.time == 0) {
			document.getElementById("proplastreaddate").value = opener.strbundle.getString("neverread");
		} else {
			date = getDateAsString(node.time);
			document.getElementById("proplastreaddate").value = date;
		}

		if (node.type == node.RESULT_TYPE_URI) {
			document.getElementById("propreadcount").value = node.accessCount;
		} else {
			document.getElementById("propreadcount").value = "0";
		}

		if (opener.PlacesUtils.annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/description")) {
			document.getElementById("propdesc").value = opener.PlacesUtils.annotations.getItemAnnotation(node.itemId, "bookmarkProperties/description");
		}
		if (node.type == node.RESULT_TYPE_URI) {
			document.getElementById("propurl").value = node.uri;
		} else {
			document.getElementById("propurl").value = livemarkService.getFeedURI(node.itemId).spec;
		}
		if (opener.PlacesUtils.annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/feedhome")) {
			document.getElementById("propfeedhome").value = opener.PlacesUtils.annotations.getItemAnnotation(node.itemId, "bookmarkProperties/feedhome");
		}
		if (opener.PlacesUtils.annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/feedwatched")) {
			if (opener.PlacesUtils.annotations.getItemAnnotation(node.itemId, "bookmarkProperties/feedwatched") == 1) {
				document.getElementById("propwatched").checked = true;
			} else {
				document.getElementById("watchlistaction").disabled = true;
			}
		} else {
			document.getElementById("watchlistaction").disabled = true;
		}

		if (opener.PlacesUtils.annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/watchaction")) {
			if (opener.PlacesUtils.annotations.getItemAnnotation(node.itemId, "bookmarkProperties/watchaction") == "Find") {
				document.getElementById("watchlistaction").selectedIndex = 0;
			} else {
				document.getElementById("watchlistaction").selectedIndex = 1;
			}
		}
	}
}

//**************************************************************************
function doUpdate() {
	var retval = false;
	if (document.getElementById("propname").value.length == 0) {
		if (node.type == node.RESULT_TYPE_FOLDER) {
			alert(opener.strbundle.getString("propnofoldername"));
		} else {
			alert(opener.strbundle.getString("propnofeedname"));
		}
	} else {
		if (node.type == node.RESULT_TYPE_FOLDER && !opener.PlacesUtils.nodeIsLivemarkContainer(node)) {
			var txn = opener.PlacesUIUtils.ptm.editItemTitle(node.itemId, document.getElementById("propname").value);
			opener.PlacesUIUtils.ptm.doTransaction(txn);
			retval = true;
		} else {
			if (document.getElementById("propurl").value.length == 0) {
				alert(opener.strbundle.getString("propnofeedurl"));
			} else {
				if (!opener.PlacesUtils.nodeIsLivemarkContainer(node)) {
					var txn = opener.PlacesUIUtils.ptm.editItemTitle(node.itemId, document.getElementById("propname").value);
					opener.PlacesUIUtils.ptm.doTransaction(txn);
					txn = opener.PlacesUIUtils.ptm.editBookmarkURI(node.itemId, IOService.newURI(document.getElementById("propurl").value, null, null));
					opener.PlacesUIUtils.ptm.doTransaction(txn);
				} else {
					livemarkService.setFeedURI(node.itemId, IOService.newURI(document.getElementById("propurl").value, null, null));
				}
				if (document.getElementById("propwatched").checked) {
					opener.PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/feedwatched", true, 1, opener.PlacesUtils.annotations.EXPIRE_NEVER);
					if (document.getElementById("watchlistaction").selectedIndex == 0) {
						opener.PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/watchaction", "Find", 3, opener.PlacesUtils.annotations.EXPIRE_NEVER);
					} else {
						opener.PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/watchaction", "Save", 3, opener.PlacesUtils.annotations.EXPIRE_NEVER);
					}
				} else {
					opener.PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/feedwatched", false, 1, opener.PlacesUtils.annotations.EXPIRE_NEVER);
				}
				retval = true;
			}
		}
	}
	return retval;
}

//**************************************************************************
function doCancel() {
	document.getElementById("wizzproperties").cancelDialog();
}

//**************************************************************************
function getDateAsString(dateval) {
	var date = new Date(dateval/1000);
	var year = date.getFullYear();
	var month = date.getMonth() + 1;
	if (month < 10) {
		month = "0" + month;
	}
	var day = date.getDate();
	if (day < 10) {
		day = "0" + day;
	}
	var hours = date.getHours();
	var ampm;
	if (hours > 11) {
		hours = hours - 12;
		ampm = "PM";
	} else {
		ampm = "AM";
	}
	if (hours < 10) {
		hours = "0" + hours;
	}
	var minutes = date.getMinutes();
	if (minutes < 10) {
		minutes = "0" + minutes;
	}
	return year + "/" + month + "/" + day + " " + hours + ":" + minutes + " " + ampm;
}

//**************************************************************************
function toggleAction() {
	if (document.getElementById("watchlistaction").disabled == false) {
		document.getElementById("watchlistaction").disabled = true;
	} else {
		document.getElementById("watchlistaction").disabled = false;
	}
}

//**************************************************************************
function gotoFeedHome(event) {
	if (document.getElementById("propfeedhome").value.length > 0) {
		opener.gotoLink(event, document.getElementById("propfeedhome").value);
	}
}