var watchRunning = false;
var wizzinterval;
var strbundle;
var myevent;
var wizzlocale;

var inHeader = false;
var titleText = "";
var opmlText = "";
var opmlMsg;
var opmlFlag;

// ds stuff
var rdfService;
var wizzds;
var feedlookup;
var subject;
var predicate;

var foundlivemarks;

//**************************************************************************
function wizztoolbarload() {

	if (readPref("WizzRSSSidebarOnRight", false, 2)) {
		moveSidebar(true);
	}

	cleanToolbar(); // This is to get rid of the crap that StumbleUpon adds to all toolbars with the attribute customizable="false"

	removeEventListener("load", wizztoolbarload, true);
	checksqlitedb();
	if (window.menubar.visible) {

		myevent = document.createEvent("Events");

		this.addEventListener("startwatch", startWatch, true);
		this.addEventListener("stopwatch", stopWatch, true);
		this.addEventListener("unload", wizztoolbarunload, true);

		strbundle = document.getElementById("wizzstrings");

		wizzlocale = strbundle.getString("wizzlocale");

		rdfService = Cc["@mozilla.org/rdf/rdf-service;1"].getService(Ci.nsIRDFService);
		wizzds = Cc["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].getService(Ci.nsIRDFDataSource);
		subject = rdfService.GetResource("http://www.wizzrss.com/rdf/watchlist/State");
		predicate = rdfService.GetResource("http://www.wizzrss.com/rdf/watchlist/running");
		var exists = wizzds.hasArcOut(subject, predicate);
		if (!exists) {
			var state = rdfService.GetLiteral("false");
			wizzds.Assert(subject, predicate, state, true);
		}

		if (!readPref("WizzRSSHideToolbarText", false, 2)) {
			document.getElementById("help-menu").setAttribute("label", strbundle.getString("help"));
			document.getElementById("options-menu").setAttribute("label", strbundle.getString("options"));
			document.getElementById("watchlist-menu").setAttribute("label", strbundle.getString("watchlist"));
			document.getElementById("weather-menu").setAttribute("label", strbundle.getString("weather"));
			document.getElementById("find-menu").setAttribute("label", strbundle.getString("find"));
		}
	
		var today = new Date();
		today.setHours(0);
		today.setMinutes(0);
		today.setSeconds(0);

		if (Date.parse(today) != readPref("WizzRSSLastCheck", "0", 1)) {
			writePref("WizzRSSLastCheck", Date.parse(today), 1);
			setTimeout("checkUpdates()", 30000);
		}
		if (readPref("WizzRSSWatchActive", false, 2)) {
			setTimeout("autoStart()", 1000);
		}

		if (readPref("WizzRSSOBID", "", 1) == "") {
			setTimeout("getOBID()", 1000);
		}
		document.getElementById("wizzSidebarKey").setAttribute("key", readPref("WizzRSSSidebarAccessKey", "Q", 1));
		document.getElementById("wizzSidebarKey").setAttribute("modifiers", readPref("WizzRSSModifier", "alt", 1));
		document.getElementById("wizzWindowKey").setAttribute("key", readPref("WizzRSSWindowAccessKey", "W", 1));
		document.getElementById("wizzWindowKey").setAttribute("modifiers", readPref("WizzRSSModifier", "alt", 1));

		var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
		os.addObserver(obs, "link-visited", false);
		os.addObserver(obs, "wlnotify", false);
		os.addObserver(obs, "em-action-requested", false);
	}
}

//**************************************************************************
function checksqlitedb() {
	var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	file.append("wizzrss");
	file.append("wizzrss.sqlite");
	if (!file.exists()) {
		file.create(file.NORMAL_FILE_TYPE, 0666);
		var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
		var mDBConn = storageService.openDatabase(file);
		mDBConn.executeSimpleSQL("CREATE TABLE lastread (feedurl TEXT, feedname TEXT, feedsubtitle TEXT)");
		mDBConn.executeSimpleSQL("CREATE TABLE readtmp (recid INTEGER PRIMARY KEY AUTOINCREMENT, feedurl TEXT, itemtitle TEXT, itemurl TEXT, enclosureurl TEXT, itemsummary TEXT, itemcontent TEXT, itemdate INTEGER, addeddate INTEGER, status INTEGER)");
		mDBConn.executeSimpleSQL("CREATE TABLE aggregated (recid INTEGER PRIMARY KEY AUTOINCREMENT, feedurl TEXT, itemtitle TEXT, itemurl TEXT, enclosureurl TEXT, itemsummary TEXT, itemcontent TEXT, itemdate INTEGER, addeddate INTEGER, status INTEGER)");
		mDBConn.executeSimpleSQL("CREATE INDEX addeddateindex ON aggregated(addeddate)");
		mDBConn.executeSimpleSQL("CREATE INDEX filterindex ON aggregated(itemtitle, itemsummary)");
		mDBConn.executeSimpleSQL("CREATE TABLE results (recid INTEGER PRIMARY KEY AUTOINCREMENT, feedurl TEXT, itemtitle TEXT, itemurl TEXT, enclosureurl TEXT, itemsummary TEXT, itemcontent TEXT, itemdate INTEGER, addeddate INTEGER, status INTEGER)");
		mDBConn.executeSimpleSQL("CREATE TABLE wlaggregated (recid INTEGER PRIMARY KEY AUTOINCREMENT, bookmarkid INTEGER, feedurl TEXT, itemtitle TEXT, itemurl TEXT, enclosureurl TEXT, itemsummary TEXT, itemcontent TEXT, itemdate INTEGER, addeddate INTEGER, status INTEGER)");
		mDBConn.executeSimpleSQL("CREATE INDEX wladdeddateindex ON wlaggregated(addeddate)");
		mDBConn.executeSimpleSQL("CREATE INDEX wlfilterindex ON wlaggregated(itemtitle, itemsummary)");
		mDBConn.executeSimpleSQL("CREATE TABLE wltmp (recid INTEGER PRIMARY KEY AUTOINCREMENT, bookmarkid INTEGER, feedurl TEXT, itemtitle TEXT, itemurl TEXT, enclosureurl TEXT, itemsummary TEXT, itemcontent TEXT, itemdate INTEGER, addeddate INTEGER, status INTEGER, itemaction TEXT)");
		mDBConn.executeSimpleSQL("CREATE INDEX itemactionindex ON wltmp(itemaction)");
		mDBConn.close();
	}
}

//**************************************************************************
var obs = {
	observe: function (subject, topic, data) {
		if (topic == "link-visited") {
			fireWizzEvent("updateind");
		} else if (topic == "wlnotify") {
			if (data == "on") {
				document.getElementById("wizzsbbutton").setAttribute("hidden", "false");
				fireWizzEvent("foundnew");
			} else if (data == "off") {
				setNormal();
			}
		} else if (topic == "em-action-requested" && data == "item-uninstalled") {
			subject.QueryInterface(Components.interfaces.nsIUpdateItem);
			if (subject.id == "{D5EDC062-A372-4936-B782-BD611DD18D86}") {
				var ans = confirm(strbundle.getString("removeFolder"));
				if (ans) {
					var node = getTreePlaceURI()[1];
					if (node != null) {
						PlacesUtils.bookmarks.removeFolder(node);
					}
				}
			}
		}
	}
};

//**************************************************************************
function cleanToolbar() {
	var tb = document.getElementById("wizzrssToolbar");
	tb.setAttribute("currentset", "titletext, wizz1, opensidebar, openwindow, wizz2, find-menu, help-menu, options-menu, watchlist-menu, weather-menu");
}

//**************************************************************************
function addWizzRSSHandler() {
	var count = 0;
	var found = false;
	var uri = readPref("browser.contentHandlers.types." + count + ".uri", "", 1);
	while (uri != "") {
		if (uri == "chrome://wizzrss/content/addfeed.xul?url=%s") {
			found = true;
			break;
		}
		count++;
		uri = readPref("browser.contentHandlers.types." + count + ".uri", "", 1);
	}
	writePref("browser.contentHandlers.auto.application/vnd.mozilla.maybe.feed", "chrome://wizzrss/content/addfeed.xul?url=%s", 1);
	writePref("browser.feeds.handlers.webservice", "chrome://wizzrss/content/addfeed.xul?url=%s", 1);
	if (!found) {
		writePref("browser.contentHandlers.types." + count + ".title", "Wizz RSS News Reader", 1);
		writePref("browser.contentHandlers.types." + count + ".type", "application/vnd.mozilla.maybe.feed", 1);
		writePref("browser.contentHandlers.types." + count + ".uri", "chrome://wizzrss/content/addfeed.xul?url=%s", 1);
	}
	alert("Please restart Firefox.");
}

//**************************************************************************
function checklivemarkfolder(node) {

	var livemarkService = Cc["@mozilla.org/browser/livemark-service;2"].getService(Ci.nsILivemarkService);
	if (livemarkService.isLivemark(node.itemId)) {
		var tmp = new Array(node.title, livemarkService.getFeedURI(node.itemId).spec);
		foundlivemarks.push(tmp);
	} else {
		var folder = node.QueryInterface(Ci.nsINavHistoryContainerResultNode);
		var currentState = folder.containerOpen;

		if (!currentState) {
			folder.containerOpen = true;
		}

		for (var i = 0; i < folder.childCount; i ++) {
			var foldernode = folder.getChild(i);
			if (foldernode.type == foldernode.RESULT_TYPE_FOLDER) {
				checklivemarkfolder(foldernode);
			}
		}
		folder.containerOpen = currentState;
	}
}

//**************************************************************************
function importlivemarks() {
	foundlivemarks = new Array();
	wizzfindlivemarks(PlacesUIUtils.allBookmarksFolderId);
	if (foundlivemarks.length > 0) {

		var importNodeId = getTreePlaceURI()[1];
		if (importNodeId == null) {
			var annotations = [];
			var txn = PlacesUIUtils.ptm.createFolder("Wizz RSS", PlacesUIUtils.allBookmarksFolderId, -1, annotations);
			PlacesUIUtils.ptm.doTransaction(txn);
			importNodeId = getTreePlaceURI()[1];
		}

		var childTransactions = [];
		for (var n = 0; n < foundlivemarks.length; n++) {
			var annotations = [];
			var anno = {
				name: DESCRIPTION_ANNO,
				type: Ci.nsIAnnotationService.TYPE_STRING,
				flags: 0,
				value: "Unread",
				expires: Ci.nsIAnnotationService.EXPIRE_NEVER
			};
		
			annotations.push(anno);
			var uri = Cc['@mozilla.org/network/standard-url;1'].createInstance(Ci.nsIURI);
			uri.spec = foundlivemarks[n][1];
			childTransactions.push(PlacesUIUtils.ptm.createItem(uri, -1, -1, foundlivemarks[n][0], "", annotations));
		}
		var annotations = [];
		var txn = PlacesUIUtils.ptm.createFolder(strbundle.getString("livemarkfoldername"), importNodeId, -1, annotations, childTransactions);
		PlacesUIUtils.ptm.doTransaction(txn);
		alert(foundlivemarks.length + " " + strbundle.getString("livemarkimportdone"));
	} else {
		alert(strbundle.getString("livemarknonefound"));
	}
}

//**************************************************************************
function wizzfindlivemarks(folder) {
	var historyService = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsINavHistoryService);
	var options = historyService.getNewQueryOptions();
	var query = historyService.getNewQuery();
	query.setFolders([folder], 1);
	var result = historyService.executeQuery(query, options);
	var rootNode = result.root;
	rootNode.containerOpen = true;
	for (var i = 0; i < rootNode.childCount; i ++) {
		var node = rootNode.getChild(i);
		if (node.type == node.RESULT_TYPE_FOLDER || node.type == node.RESULT_TYPE_FOLDER_SHORTCUT) {
			checklivemarkfolder(node);
		}
	}
	rootNode.containerOpen = false;
}

//**************************************************************************
function autoStart() {
	if (readPref("WizzRSSWatchActive", false, 2) && !getWLState()) {
		watchRunning = true;
		setWLState(true);
		document.getElementById("sbpwlactive").setAttribute("hidden", "false");
		setTimeout("firstWatch()", 60000);
	}
}

//**************************************************************************
function wizztoolbarunload(event) {
	if (event.target.documentURI == "chrome://browser/content/browser.xul") {
		try {
			this.removeEventListener("startwatch", startWatch, true);
			this.removeEventListener("stopwatch", stopWatch, true);
			this.removeEventListener("unload", wizztoolbarunload, true);
			if (getWLState() && watchRunning) {
				stopWatch();
			}
			var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
			os.removeObserver(obs, "link-visited");
			os.removeObserver(obs, "wlnotify");
			os.removeObserver(obs, "em-action-requested");
		} catch (e) {}
	}
}

//**************************************************************************
function getWLState() {
	var retval = false;
	var running = wizzds.GetTarget(subject, predicate, true);
	if (running instanceof Ci.nsIRDFLiteral){
		if (running.Value == "true") {
			retval = true;
		}
	}
	return retval;
}

//**************************************************************************
function setWLState(state) {
	if (state) {
		wizzds.Change(subject, predicate, rdfService.GetLiteral("false"), rdfService.GetLiteral("true"));
	} else {
		wizzds.Change(subject, predicate, rdfService.GetLiteral("true"), rdfService.GetLiteral("false"));
	}
}

//**************************************************************************
function getOBID() {
	var xmlReq = new XMLHttpRequest();
	xmlReq.open("GET", "http://www.wizzrss.com/wizzrss2/getOBID.php");
	xmlReq.onload = setOBID;
	xmlReq.send(null);
}

//**************************************************************************
function setOBID(event) {
	var text = event.target.responseText;
	writePref("WizzRSSOBID", text, 1);
}

//**************************************************************************
function checkUpdates() {
	var xmlReq = new XMLHttpRequest();
	xmlReq.open("GET", "http://www.wizzrss.com/wizzrss2/ShowNum.php?ver=" + wizzversion, true);
	xmlReq.onload = showNumOnLoad;
	xmlReq.send(null);
}

//**************************************************************************
function showWizzRSS() {
	if (readPref("WizzRSSOpenAsWindow", false, 2)) {
		toOpenWindowByType('wizzrss:main', 'chrome://wizzrss/content/wizzrss.xul');
	} else {
		toggleSidebar('WizzRSSSidebar');
	}
}

//**************************************************************************
function toggleWizzToolbar() {
	var tb = document.getElementById("wizzrssToolbar");
	if (tb.collapsed) {
		tb.setAttribute("collapsed", "false");
	} else {
		tb.setAttribute("collapsed", "true");
	}
}

//**************************************************************************
function toggleToolbarText(val) {
	if (val) {
		document.getElementById("help-menu").setAttribute("label", "");
		document.getElementById("options-menu").setAttribute("label", "");
		document.getElementById("watchlist-menu").setAttribute("label", "");
		document.getElementById("weather-menu").setAttribute("label", "");
		document.getElementById("find-menu").setAttribute("label", "");
	} else {
		document.getElementById("help-menu").setAttribute("label", strbundle.getString("help"));
		document.getElementById("options-menu").setAttribute("label", strbundle.getString("options"));
		document.getElementById("watchlist-menu").setAttribute("label", strbundle.getString("watchlist"));
		document.getElementById("weather-menu").setAttribute("label", strbundle.getString("weather"));
		document.getElementById("find-menu").setAttribute("label", strbundle.getString("find"));
	}
}

//**************************************************************************
function moveSidebar(val) {
	if (val) {
		document.getElementById("main-window").setAttribute("wizzorient", "right");
	} else {
		document.getElementById("main-window").setAttribute("wizzorient", "left");
	}
}

//**************************************************************************
function showNumOnLoad(event) {
	var text = event.target.responseText;
	if (text == "invalid") {
		writePref("WizzRSSLastCheck", "0", 1);
		var tab = getContentBrowser().addTab("http://www.wizzrss.com/Invalid.php");
		getContentBrowser().selectedTab = tab;
	} else {
		if (!isNaN(parseInt(text))) {
			if (text != readPref("WizzRSSShowNum", "", 1)) {
				writePref("WizzRSSShowNum", text, 1);
				getContentBrowser().addTab("http://www.wizzrss.com/Welcome.php");
				try {
					var alerts = Cc["@mozilla.org/alerts-service;1"].getService(Ci.nsIAlertsService);
					alerts.showAlertNotification("chrome://wizzrss/content/wizzrss_icon.png", "Wizz RSS " + wizzversion, strbundle.getString("welcomepage"), false, "", null);
				} catch (e) {
					alert(strbundle.getString("welcomepage"));
				}
			}
		}
	}
}

//**************************************************************************
function wlbusyOn() {
	document.getElementById("sbpwlbusy").setAttribute("hidden", "false");
}

//**************************************************************************
function wlbusyOff() {
	document.getElementById("sbpwlbusy").setAttribute("hidden", "true");
}

//**************************************************************************
function firstWatch() {
	var period = readPref("WizzRSSWatchInterval", 30, 3);
	period = period * 1000 * 60;
	wizzinterval = setInterval("doWatch()", period);
	doWatch();
}

//**************************************************************************
function startWatch() {
	if (!getWLState() && !watchRunning) {
		document.getElementById("sbpwlactive").setAttribute("hidden", "false");
		var period = readPref("WizzRSSWatchInterval", 30, 3);
		period = period * 1000 * 60;
		wizzinterval = setInterval("doWatch()", period);
		setWLState(true);
		watchRunning = true;
		doWatch();
	} else {
		alert(strbundle.getString("starterror"));
	}
}

//**************************************************************************
function stopWatch() {
	if (getWLState() && watchRunning) {
		clearInterval(wizzinterval);
		document.getElementById("sbpwlactive").setAttribute("hidden", "true");
		setWLState(false);
		watchRunning = false;
	} else {
		if (getWLState() && !watchRunning) {
			alert(strbundle.getString("stoperror"));
		}
	}
}

//**************************************************************************
function runNow() {
	if (!getWLState()) {
		watchRunning = true;
		doWatch();
		watchRunning = false;
	} else {
		alert(strbundle.getString("starterror"));
	}
}

//**************************************************************************
function doWatch() {
	if (watchRunning) {
		new watchReader().processWatch();
	}
}

//**************************************************************************
function watchReader() {

	this.file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	this.file.append("wizzrss");
	this.file.append("wizzrss.sqlite");
	this.storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	this.mDBConn = this.storageService.openDatabase(this.file);
	this.wltmpstatement = this.mDBConn.createStatement("INSERT INTO wltmp (recid, bookmarkid, feedurl, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate, addeddate, status, itemaction) VALUES (NULL, ?1, ?2, ?3, ?4, ?5, ?6, ?7, ?8, ?9, 0, ?10)");

	this.watchArray = new Array();
	this.feedsToWatch = new Array();
	this.watchToRead = 0;
	this.watchRead = 0;
	this.notitle = strbundle.getString("notitle");
	this.addedDate = new Date().getTime();
}

watchReader.prototype = {

	processWatch: function processWatch() {
		try {
			wlbusyOn();
			this.findWatchedFeeds();
			this.deleteTempData();
			for (var n = 0; n < this.feedsToWatch.length; n++) {
				this.watchToRead++;
				var url = this.feedsToWatch[n][0];
				var xmlReq = new XMLHttpRequest();
				xmlReq.setCallback(this);
				xmlReq.open("GET", url, true);
				xmlReq.onload = this.onWatchLoad;
				xmlReq.onerror = this.onWatchError;
				xmlReq.setRequestHeader("User-Agent", "Wizz RSS News Reader");
				xmlReq.overrideMimeType("application/xml");
				xmlReq.send(null);
			}
			if (this.watchToRead == 0) {
				wlbusyOff();
				stopWatch();
			}
		} catch (e) {
			alert(e);
			wlbusyOff();
			stopWatch();
		}
	},

	// This is part of the redirect fix
	processRedirect: function processRedirect(URL) {
		try {
			var xmlReq = new XMLHttpRequest();
			xmlReq.setCallback(this);
			xmlReq.open("GET", URL, true);
			xmlReq.onload = this.onWatchLoad;
			xmlReq.onerror = this.onWatchError;
			xmlReq.setRequestHeader("User-Agent", "Wizz RSS News Reader");
			xmlReq.overrideMimeType("application/xml");
			xmlReq.send(null);
		} catch (e) {
			wlbusyOff();
			stopWatch();
		}
	},

	onWatchError: function onWatchError(event) {
		var callback = event.target.getCallback();
		callback.handleError();
	},

	handleError: function handleError() {
		this.watchRead++;
		if (this.watchToRead == this.watchRead) {
			wlbusyOff();
			this.processWatchData();
		}
	},

	onWatchLoad: function onWatchLoad(event) {
		var callback = event.target.getCallback();

		// This is part of the redirect fix
		var location = event.target.getResponseHeader("location");
		if (location) {
			callback.changeFeedUrl(event.target.channel.originalURI.spec, location);
			callback.processRedirect(location);
			return;
		}

		var data = event.target.responseText;

		if (data.indexOf("<media:group") != -1) {
			data = cleanFeed(event.target.responseXML);
		}

		if (data.length) {
			var parser = Components.classes["@mozilla.org/feed-processor;1"].createInstance(Components.interfaces.nsIFeedProcessor);
			try {
				parser.listener = callback;
				parser.parseFromString(data, event.target.channel.originalURI);
			} catch(e) {}
		} else {
			callback.handleError();
		}
	},

	// This is part of the redirect fix
	changeFeedUrl: function changeFeedUrl(oldURL, newURL) {
		for (var x = 0; x < this.feedsToWatch.length; x++) {
			if (this.feedsToWatch[x][0] == oldURL) {
				this.feedsToWatch[x][0] = newURL;
				break;
			}
		}
	},

	findWatchedFeeds: function findWatchedFeeds() {
		var pmDBConn = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsINavHistoryService).QueryInterface(Ci.nsPIPlacesDatabase).DBConnection;
		var statement = pmDBConn.createStatement("SELECT url, a.id FROM (SELECT id, fk FROM moz_bookmarks WHERE id IN (SELECT moz_items_annos.item_id FROM moz_items_annos, moz_anno_attributes WHERE moz_items_annos.anno_attribute_id = moz_anno_attributes.id AND moz_anno_attributes.name = 'bookmarkProperties/feedwatched' AND moz_items_annos.content = 1 AND fk IS NOT NULL)) AS a, (SELECT content, item_id FROM moz_items_annos, moz_anno_attributes WHERE anno_attribute_id = moz_anno_attributes.id AND moz_anno_attributes.name = 'bookmarkProperties/watchaction') AS b, (SELECT id, url FROM moz_places) AS c WHERE a.id = b.item_id AND a.fk = c.id");
		while (statement.executeStep()) {
			var tmp = new Array(statement.getString(0), statement.getString(1));
			this.feedsToWatch.push(tmp);
		}
		statement.reset();
		statement.finalize();
		var statement = pmDBConn.createStatement("SELECT content, id FROM (SELECT id, title	FROM moz_bookmarks WHERE id IN (SELECT moz_items_annos.item_id FROM moz_items_annos, moz_anno_attributes WHERE moz_items_annos.anno_attribute_id = moz_anno_attributes.id AND moz_anno_attributes.name = 'bookmarkProperties/feedwatched' AND moz_items_annos.content = 1 AND fk IS NULL)) AS a, (SELECT content, item_id FROM moz_items_annos, moz_anno_attributes WHERE anno_attribute_id = moz_anno_attributes.id AND moz_anno_attributes.name = 'livemark/feedURI') AS b WHERE a.id = b.item_id");
		while (statement.executeStep()) {
			var tmp = new Array(statement.getString(0), statement.getString(1));
			this.feedsToWatch.push(tmp);
		}
		statement.reset();
		statement.finalize();
	},

	handleResult: function handleResult(result) {
		this.watchRead++;
		if (result) {
			var feed = result.doc;
			if (feed) {

				var bookmarkid;
				var spec = result.uri.spec;
				for (var n = 0; n < this.feedsToWatch.length; n++) {
					if (spec == this.feedsToWatch[n][0]) {
						bookmarkid = this.feedsToWatch[n][1];
						break;
					}
				}

				feed.QueryInterface(Ci.nsIFeed);
				if (feed.items.length) {
					this.mDBConn.beginTransaction();
					var feedsubtitle = "";
					if (feed.subtitle) {
						feedsubtitle = feed.subtitle.text;
					}
					var feedlink = "none";
					if (feed.link) {
						feedlink = feed.link.spec;
					}
					PlacesUtils.annotations.setItemAnnotation(bookmarkid, "bookmarkProperties/feedhome", feedlink, 3, PlacesUtils.annotations.EXPIRE_NEVER);
					PlacesUtils.annotations.setItemAnnotation(bookmarkid, "bookmarkProperties/description", feedsubtitle, 3, PlacesUtils.annotations.EXPIRE_NEVER);

					var historyService = Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService);
					time = new Date().valueOf();
					time = time * 1000;
					historyService.addVisit(result.uri, time, null, 3, false, 0);

					var itemArray = feed.items;
					for (var n = 0; n < itemArray.length; n++) {
						var entry = itemArray.queryElementAt(n, Ci.nsIFeedEntry);

						var itemTitle = this.notitle;
						var itemLink = "";
						var itemEnclosure = "";
						var itemSummary = "";
						var itemContent = "";
						var itemUpdated = "";
						var itemPublished = "";
						if (entry.title) {
							if (entry.title.text != null && trim(entry.title.text).length > 0) {
								itemTitle = entry.title.text;
							}
						}
						if (entry.link) {
							itemLink = entry.link.spec;
						}
						if (entry.enclosures) {
							var enc = entry.enclosures.queryElementAt(0, Components.interfaces.nsIWritablePropertyBag2);
							if (enc.hasKey("url")) {
            							itemEnclosure = enc.get("url");
							}
						}
						if (entry.summary) {
							if (entry.summary.text != null && trim(entry.summary.text).length > 0) {
								itemSummary = entry.summary.text;
							}
						}
						if (entry.content) {
							if (entry.content.text != null && trim(entry.content.text).length > 0) {
								itemContent = entry.content.text;
							}
						}
						if (entry.updated) {
							itemUpdated = entry.updated;
						}
						if (entry.published) {
							itemPublished = entry.published;
						}

						var itemDate = "";
						if (itemPublished != "") {
							itemDate = itemPublished;
						} else if (itemUpdated != "") {
							itemDate = itemUpdated;
						}

						if (itemDate.length > 0) {
							itemDate = new Date(itemDate).getTime();
						} else {
							itemDate = this.addedDate;
						}

						this.writedata(bookmarkid, spec, itemTitle, itemLink, itemEnclosure, itemSummary, itemContent, itemDate);
					}
					this.mDBConn.commitTransaction();
				}
			}
		}
		if (this.watchToRead == this.watchRead) {
			wlbusyOff();
			this.processWatchData();
		}
	},

	writedata: function writedata(bookmarkid, feedurl, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate) {

		itemtitle = itemtitle.replace(/\t/g, ' ');
		itemtitle = htmlToText(wizzSanitizer.cleanElement(itemtitle));
		itemurl = wizzSanitizer.cleanElement(itemurl);
		itemsummary = wizzSanitizer.cleanElement(itemsummary);
		itemcontent = wizzSanitizer.cleanElement(itemcontent);
		if (enclosureurl.length != 0) {
			enclosureurl = wizzSanitizer.cleanElement(enclosureurl);
		}
		if (itemurl.length == 0 && enclosureurl.length != 0) {
			itemurl = enclosureurl;
		}

		var itemHistFlag = wizzHistory.checkHist(itemurl);
		var encHistFlag = wizzHistory.checkHist(enclosureurl);
		if (!itemHistFlag || !encHistFlag) {
			this.wltmpstatement.bindInt32Parameter(0, bookmarkid);
			this.wltmpstatement.bindStringParameter(1, feedurl);
			this.wltmpstatement.bindUTF8StringParameter(2, itemtitle);
			this.wltmpstatement.bindStringParameter(3, itemurl);
			this.wltmpstatement.bindStringParameter(4, enclosureurl);
			this.wltmpstatement.bindUTF8StringParameter(5, itemsummary);
			this.wltmpstatement.bindUTF8StringParameter(6, itemcontent);
			this.wltmpstatement.bindInt64Parameter(7, itemdate);
			this.wltmpstatement.bindInt64Parameter(8, this.addedDate);
			this.wltmpstatement.bindStringParameter(9, PlacesUtils.annotations.getItemAnnotation(bookmarkid, "bookmarkProperties/watchaction"));
			this.wltmpstatement.execute();
		}
	},

	deleteTempData: function deleteTempData() {
		this.mDBConn.executeSimpleSQL("DELETE FROM wltmp");
	},

	processWatchData: function processWatchData() {
		this.wltmpstatement.reset();
		this.wltmpstatement.finalize();
		this.mDBConn.executeSimpleSQL("DELETE FROM wltmp WHERE recid NOT IN (SELECT MIN(recid) FROM wltmp GROUP BY itemurl)");
		this.mDBConn.executeSimpleSQL("DELETE FROM wltmp WHERE itemurl IN (SELECT DISTINCT wltmp.itemurl FROM wltmp, wlaggregated WHERE wltmp.itemurl = wlaggregated.itemurl AND wltmp.itemaction='Find')");
		this.mDBConn.executeSimpleSQL("INSERT INTO wlaggregated SELECT recid, bookmarkid, feedurl, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate, addeddate, status FROM wltmp WHERE itemaction = 'Find'");

		var statement = this.mDBConn.createStatement("SELECT COUNT(*) FROM wltmp WHERE itemaction='Find'");
		var findcount = 0;
		while (statement.executeStep()) {
			findcount = statement.getInt32(0);
		}
		statement.reset();
		statement.finalize();
		if (findcount != 0) {

			statement = this.mDBConn.createStatement("SELECT bookmarkid FROM wltmp WHERE itemaction='Find' GROUP BY bookmarkid");
			while (statement.executeStep()) {
				PlacesUtils.annotations.setItemAnnotation(statement.getInt32(0), "bookmarkProperties/feedstatus", "Unread", 3, PlacesUtils.annotations.EXPIRE_NEVER);
			}
			statement.reset();
			statement.finalize();

			var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
			os.notifyObservers(this, "wlnotify", "on");
			if (readPref("WizzRSSWatchListAlert", false, 2)){
				try {
					var alerts = Cc["@mozilla.org/alerts-service;1"].getService(Ci.nsIAlertsService);
					alerts.showAlertNotification("chrome://wizzrss/content/wizzrss_icon.png", "Wizz RSS " + wizzversion, strbundle.getString("watchalert"), true, "", listener);
				} catch (e) {
					alert(strbundle.getString("watchalert"));
				}
			}
			if (readPref("WizzRSSPlaySound", false, 2)){
				var soundURL = readPref("WizzRSSSoundFile", "", 1);
				soundURL = "file:///" + soundURL.replace(/\\/g, "/");
				var gSound = Cc["@mozilla.org/sound;1"].createInstance(Ci.nsISound);
				var ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
				var url = ioService.newURI(soundURL, null, null);
				gSound.play(url);
			}
		}

		statement = this.mDBConn.createStatement("SELECT COUNT(*) FROM wltmp WHERE itemaction='Save'");
		var findcount = 0;
		while (statement.executeStep()) {
			findcount = statement.getInt32(0);
		}
		statement.reset();
		statement.finalize();
		if (findcount != 0) {
			var tmp = new Array();
			var titleText = "";
			var bookmarkid = 0;
			var path = readPref("WizzRSSSavePath", fixpath(getWizzPath() + "wizzsaved"), 1);
			var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
			var statement = this.mDBConn.createStatement("SELECT bookmarkid, itemurl, enclosureurl FROM wltmp WHERE itemaction='Save' ORDER BY bookmarkid");
			while (statement.executeStep()) {
				var bmid = statement.getInt32(0);
				var itemurl = statement.getString(1);
				var enclosureurl = statement.getString(2);
				if (bmid != bookmarkid) {
					bookmarkid = bmid;
					titleText = bmsvc.getItemTitle(bookmarkid);
					PlacesUtils.annotations.setItemAnnotation(bookmarkid, "bookmarkProperties/feedstatus", "Read", 3, PlacesUtils.annotations.EXPIRE_NEVER);
				}
				wizzHistory.addHist(itemurl);
				tmp.push(itemurl + "-;-" + titleText);
				if (enclosureurl.length != 0 && enclosureurl != itemurl) {
					wizzHistory.addHist(enclosureurl);
					tmp.push(enclosureurl + "-;-" + titleText);
				}
			}
			statement.reset();
			statement.finalize();
			fireWizzEvent("updateind");
			var dialogURL = "chrome://wizzrss/content/saveenc.xul";
			var options = "chrome";
			window.openDialog(dialogURL, "", options, tmp, path, "auto");
		}
		this.mDBConn.close();
	}
}

//**************************************************************************
var listener = {
	observe: function(subject, topic, data) {
		if (topic == "alertclickcallback") {
			var windowManager = Cc['@mozilla.org/appshell/window-mediator;1'].getService(Ci.nsIWindowMediator);
			var topWindowOfType = windowManager.getMostRecentWindow("navigator:browser");
			topWindowOfType.focus();
			showWizzRSS();
		}
	}
}

//**************************************************************************
function setNormal() {
	document.getElementById("wizzsbbutton").setAttribute("hidden", "true");
}

//**************************************************************************
function fireWizzEvent(eventString) {
	myevent.initEvent(eventString, true, false);
	dispatchEvent(myevent);
}

//**************************************************************************
function busyOn() {
	document.getElementById("checking").setAttribute("src", "chrome://wizzrss/skin/busy.gif");
}

//**************************************************************************
function busyOff() {
	document.getElementById("checking").setAttribute("src", "");
}

//**************************************************************************
function opmlImpFile() {
	var filepicker = Cc["@mozilla.org/filepicker;1"].createInstance(Ci.nsIFilePicker);
	filepicker.init(window, strbundle.getString("opmlImpFileTitle"), filepicker.modeOpen);
	filepicker.appendFilter("opml" + " (*.xml, *.opml)", "*.xml;*.opml");
	filepicker.appendFilters(filepicker.filterAll);
	var res = filepicker.show();
	if(res == filepicker.returnOK) {
		busyOn();
		opmlMsg = strbundle.getString("opmlInvalidFile");
		var url = filepicker.file.path;
		url = url.replace(/\\/g, '/');
		url = "file:///" + url;
		try {
			busyOn();
			var xmlReq = new XMLHttpRequest();
			xmlReq.open("GET", url, true);
			xmlReq.onload = opmlImpOnLoad;
			xmlReq.onerror = opmlImpError;
			xmlReq.overrideMimeType("application/xml");
			xmlReq.send(null);
		} catch (e) {
			busyOff();
			alert(strbundle.getString(opmlMsg));
		}
	}
}

//**************************************************************************
function opmlImpURL(val) {
	var url;
	if (val == null) {
		url = prompt(strbundle.getString("opmlImpURLPropmt"), "", strbundle.getString("opmlImpURLTitle"));
	} else {
		url = val;
	}
	if (url != null && url.length > 0) {
		busyOn();
		opmlMsg = strbundle.getString("opmlInvalidURL");
		try {
			var xmlReq = new XMLHttpRequest();
			xmlReq.open("GET", url, true);
			xmlReq.onload = opmlImpOnLoad;
			xmlReq.onerror = opmlImpError;
			xmlReq.overrideMimeType("application/xml");
			xmlReq.send(null);
		} catch (e) {
			busyOff();
			alert(opmlMsg);
		}
	}
}

//**************************************************************************
function opmlImpError(event) {
	busyOff();
	alert(opmlMsg);
}

//**************************************************************************
function opmlImpOnLoad(event) {
	opmlFlag = true;
	response = event.target.responseXML;
	BMSVC.runInBatchMode(parseOMPLBatch, null);
}

var parseOMPLBatch = {

	runBatched: function parseOPML() {
		if (response.firstChild.nodeName != "parsererror") {
			if (response.documentElement.localName == "opml") {
				var folder = getTreePlaceURI()[1];
				if (folder == null) {
					folder = BMSVC.createFolder(PlacesUIUtils.allBookmarksFolderId, "Wizz RSS", BMSVC.DEFAULT_INDEX);
				}
				var bodyNodes = response.getElementsByTagName("body");
				if (bodyNodes.length == 0) {
					folder = BMSVC.createFolder(folder, "OPML Import", -1);
				}
				var nodes = response.childNodes;
				for (var n = 0; n < nodes.length; n++) {
					if (nodes[n].childNodes.length > 0) {
						this.procNode(nodes[n], folder, opmlFlag);
					}
				}
				busyOff();
			} else {
				busyOff();
				alert(opmlMsg);
			}
		} else {
			busyOff();
			alert(opmlMsg);
		}
	},

	procNode: function procNode(node, folder, flag) {

		if (node.nodeName == "head") {
			inHeader = true;
		} else if (node.nodeName == "title" && inHeader) {
			titleText = node.firstChild.nodeValue;
		} else if (node.nodeName == "body") {
			inHeader = false;
			if (titleText.length == 0) {
				titleText = "OPML Import";
			}
			if (flag) {
				folder = BMSVC.createFolder(folder, titleText, -1);
			}
			titleText = "";
		}

		var nodes = node.childNodes;
		var tmptext;
		if (nodes.length > 0) {
			if (node.nodeName == "outline" && node.hasAttributes()) {
				try {
					tmptext = node.attributes.getNamedItem("text").firstChild.nodeValue;
				} catch (e) {
					try {
						tmptext = node.attributes.getNamedItem("title").firstChild.nodeValue;
					} catch (e) {
						tmptext = "No Title";
					}
				}
				folder = BMSVC.createFolder(folder, tmptext, -1);
			}
			for (var n = 0; n < nodes.length; n++) {
				procNode(nodes[n], folder, flag);
			}
		} else {
			if (node.nodeName == "outline") {
				try {
					tmptext = node.attributes.getNamedItem("text").firstChild.nodeValue;
				} catch (e) {
					try {
						tmptext = node.attributes.getNamedItem("title").firstChild.nodeValue;
					} catch (e) {
						tmptext = "No Title";
					}
				}
				var stattext;
				try {
					stattext = node.attributes.getNamedItem("wizzstat").firstChild.nodeValue;
					if (stattext == "") {
						stattext = "Unread";
					}
				} catch (e) {
					stattext = "Unread";
				}
				var homeUrl;
				try {
					homeUrl = node.attributes.getNamedItem("feedHome").firstChild.nodeValue;
				} catch (e) {
					homeUrl = null;
				}
				var watched;
				try {
					watched = node.attributes.getNamedItem("watched").firstChild.nodeValue;
				} catch (e) {
					watched = null;
				}
				var action;
				try {
					action = node.attributes.getNamedItem("action").firstChild.nodeValue;
				} catch (e) {
					action = null;
				}
				var uri = IOService.newURI(node.attributes.getNamedItem("xmlUrl").firstChild.nodeValue, null, null)
				var newBM = BMSVC.insertBookmark(folder, uri, -1, tmptext);
				if (homeUrl != null) {
					annotations.setPageAnnotation(uri, "bookmarkProperties/feedhome", homeUrl, 0, annotations.EXPIRE_NEVER);
					annotations.setItemAnnotation(newBM, "bookmarkProperties/feedhome", homeUrl, 0, annotations.EXPIRE_NEVER);
				}
				if (watched != null) {
					annotations.setItemAnnotation(newBM, "bookmarkProperties/feedwatched", true, 1, annotations.EXPIRE_NEVER);
					if (action == null) {
						annotations.setItemAnnotation(newBM, "bookmarkProperties/watchaction", "Find", 3, annotations.EXPIRE_NEVER);
					} else {
						annotations.setItemAnnotation(newBM, "bookmarkProperties/watchaction", action, 3, annotations.EXPIRE_NEVER);
					}
				}
				annotations.setPageAnnotation(uri, "bookmarkProperties/feedstatus", stattext, 0, annotations.EXPIRE_NEVER);
				annotations.setItemAnnotation(newBM, "bookmarkProperties/feedstatus", stattext, 0, annotations.EXPIRE_NEVER);
			}
		}
	}
}


//**************************************************************************
function opmlExport() {

	var folder = getTreePlaceURI()[1];
	if (folder == null) {
		alert(strbundle.getString("opmlExportNoData"));
	} else {
		var filepicker = Cc["@mozilla.org/filepicker;1"].createInstance(Ci.nsIFilePicker);
		filepicker.init(window, strbundle.getString("opmlExportTitle"), filepicker.modeSave);
		filepicker.appendFilter("opml" + " (*.xml, *.opml)", "*.xml;*.opml");
		filepicker.appendFilters(filepicker.filterAll);
		filepicker.defaultString = "OPMLExport.opml";
		var res = filepicker.show();
		if(res == filepicker.returnOK || res == filepicker.returnReplace) {
			opmlText = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
			opmlText += "<opml version=\"1.0\">\n";
			opmlText += "\t<head>\n";
			opmlText += "\t\t<title>Wizz RSS OPML Export</title>\n";
			opmlText += "\t</head>\n";
			opmlText += "\t<body>\n";

			var historyService = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsINavHistoryService);
			var options = historyService.getNewQueryOptions();
			var query = historyService.getNewQuery();
			query.setFolders([folder], 1);
			var result = historyService.executeQuery(query, options);
			var rootNode = result.root;
			rootNode.containerOpen = true;
			for (var i = 0; i < rootNode.childCount; i ++) {

				var node = rootNode.getChild(i);
				if (node.type == node.RESULT_TYPE_FOLDER && !PlacesUtils.nodeIsLivemarkContainer(node)) {
					opmlText += "\t\t<outline text=\"" + fixString(node.title) + "\">\n";
					procFolder("\t\t", node);
				} else if (node.type == node.RESULT_TYPE_URI || PlacesUtils.nodeIsLivemarkContainer(node)) {
					writeOPMLNode("\t\t", node);
				}
			}

			opmlText += "\t</body>\n";
			opmlText += "</opml>\n";
			writeFile(convertCharSet(opmlText, "UTF-8"), filepicker.file.path);
			opmlText = "";			
		}
	}
}

//**************************************************************************
function procFolder(padding, node) {
	
	var folder = node.QueryInterface(Ci.nsINavHistoryContainerResultNode);
	var currentState = folder.containerOpen;

	if (!currentState) {
		folder.containerOpen = true;
	}

	for (var i = 0; i < folder.childCount; i ++) {
		var foldernode = folder.getChild(i);
		if (foldernode.type == foldernode.RESULT_TYPE_FOLDER && !PlacesUtils.nodeIsLivemarkContainer(foldernode)) {
			opmlText += padding + "\t<outline text=\"" + fixString(foldernode.title) + "\">\n";
			procFolder(padding + "\t", foldernode);
		} else if (foldernode.type == foldernode.RESULT_TYPE_URI || PlacesUtils.nodeIsLivemarkContainer(foldernode)) {
			writeOPMLNode(padding, foldernode);
		}
	}
	folder.containerOpen = currentState;
	opmlText += padding + "</outline>\n";
}

//**************************************************************************
function writeOPMLNode(padding, node) {
	var feedhome = "";
	if (annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/feedhome")) {
		feedhome = annotations.getItemAnnotation(node.itemId, "bookmarkProperties/feedhome");
	}

	var feedstatus = "Unread";
	if (annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/feedstatus")) {
		feedstatus = annotations.getItemAnnotation(node.itemId, "bookmarkProperties/feedstatus");
	}

	var watched = false;
	if (annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/feedwatched")) {
		watched = annotations.getItemAnnotation(node.itemId, "bookmarkProperties/feedwatched");
	}

	var action;
	if (annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/watchaction")) {
		action = annotations.getItemAnnotation(node.itemId, "bookmarkProperties/watchaction");
	}

	var xmlurl;
	if (PlacesUtils.nodeIsLivemarkContainer(node)) {
		var livemarkService = Cc["@mozilla.org/browser/livemark-service;2"].getService(Ci.nsILivemarkService);
		xmlurl = livemarkService.getFeedURI(node.itemId).spec;
	} else {
		xmlurl = node.uri;
	}
	if (watched) {
		opmlText += padding + "\t<outline text=\"" + fixString(node.title) + "\" type=\"rss\" xmlUrl=\"" + fixString(xmlurl) + "\" wizzstat=\"" + feedstatus + "\" feedHome=\"" + fixString(feedhome) + "\" watched=\"true\" action=\"" + action + "\"/>\n";
	} else {
		opmlText += padding + "\t<outline text=\"" + fixString(node.title) + "\" type=\"rss\" xmlUrl=\"" + fixString(xmlurl) + "\" wizzstat=\"" + feedstatus + "\" feedHome=\"" + fixString(feedhome) + "\"/>\n";
	}
}

//**************************************************************************
function fixString(text) {
	var retval = "";
	for (var n = 0; n < text.length; n++) {
		var num = text.charCodeAt(n);
		if (num == 34 || num == 38 || num == 39 || num == 60 || num == 62 || num == 43) {
			retval += "&#" + num + ";";
		} else {
			retval += String.fromCharCode(num);
		}
	}
	return retval;
}

//**************************************************************************
function saveFeeds() {

	var uname = readPref("WizzRSSUserName", "", 1);
	pword = readPref("WizzRSSPassword", "", 1);

	if (!readPref("WizzRSSSavePassword", true, 2)) {
		pword = null;
		var dialogURL = "chrome://wizzrss/content/password.xul";
		var options = "chrome, modal";
		window.openDialog(dialogURL, "", options, "0");
	}

	if (pword != null) {
		if (uname == "" || pword == "") {
			alert(strbundle.getString("nocredentials"));
		} else {
			var folder = getTreePlaceURI()[1];
			if (folder == null) {
				alert(strbundle.getString("opmlSaveNoData"));
			} else {
				opmlText = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
				opmlText += "<opml version=\"1.0\">\n";
				opmlText += "\t<head>\n";
				opmlText += "\t\t<title>Restored from Server</title>\n";
				opmlText += "\t</head>\n";
				opmlText += "\t<body>\n";

				var historyService = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsINavHistoryService);
				var options = historyService.getNewQueryOptions();
				var query = historyService.getNewQuery();
				query.setFolders([folder], 1);
				var result = historyService.executeQuery(query, options);
				var rootNode = result.root;
				rootNode.containerOpen = true;
				for (var i = 0; i < rootNode.childCount; i ++) {
					var node = rootNode.getChild(i);
					if (node.type == node.RESULT_TYPE_FOLDER) {
						opmlText += "\t\t<outline text=\"" + fixString(node.title) + "\">\n";
						procFolder("\t\t", node);
					} else if (node.type == node.RESULT_TYPE_URI) {
						writeOPMLNode("\t\t", node);
					}
				}
				rootNode.containerOpen = false;
				opmlText += "\t</body>\n";
				opmlText += "</opml>\n";

				busyOn();

				var xmlReq = new XMLHttpRequest();
				xmlReq.open("POST", "http://www.wizzrss.com/wizzrss2/SaveFeeds.php?uname=" + uname + "&pword=" + pword + "&loc=" + wizzlocale + "&ver=" + wizzversion, true);
				xmlReq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
				xmlReq.onload = saveOnLoad;
				xmlReq.onerror = saveError;
				xmlReq.send("&data=" + escape(convertCharSet(opmlText, "UTF-8")));
				opmlText = "";
			}
		}
	}
}

//**************************************************************************
function saveOnLoad(event) {
	busyOff();
	var text = event.target.responseText;
	if (text.substring(0, 2) == "OK") {
		alert(unescape(text.substring(2)));
	} else if (text.substring(0, 2) == "KO") {
		alert(unescape(text.substring(2)));
	} else {
		alert(strbundle.getString("serverresperr"));
	}
}

//**************************************************************************
function saveError(event) {
	busyOff();
	alert(strbundle.getString("serverresperr"));
}

//**************************************************************************
function restFeeds() {
	var uname = readPref("WizzRSSUserName", "", 1);
	pword = readPref("WizzRSSPassword", "", 1);
	if (!readPref("WizzRSSSavePassword", true, 2)) {
		pword = null;
		var dialogURL = "chrome://wizzrss/content/password.xul";
		var options = "chrome, modal";
		window.openDialog(dialogURL, "", options, "0");
	}
	if (pword != null) {
		if (uname == "" || pword == "") {
			alert(strbundle.getString("nocredentials"));
		} else {
			busyOn();
			var xmlReq = new XMLHttpRequest();
			xmlReq.open("GET", "http://www.wizzrss.com/wizzrss2/RestFeeds.php?uname=" + uname + "&pword=" + pword + "&loc=" + wizzlocale + "&ver=" + wizzversion, true);
			xmlReq.onload = restOnLoad;
			xmlReq.onerror = saveError;
			xmlReq.send(null);
		}
	}
}

//**************************************************************************
function restOnLoad(event) {
	busyOff();
	var fireChangeID = false;
	var text = event.target.responseText;
	if (text.substring(0, 2) == "OK") {
		var parser = new DOMParser();
		var doc = parser.parseFromString(unescape(text.substring(2)), "text/xml");
		opmlMsg = strbundle.getString("restoreError");
		if (doc.firstChild.nodeName != "parsererror") {
			if (confirm(strbundle.getString("restoreConfirm"))) {
				fireChangeID = true;
				var node = getTreePlaceURI()[1];
				if (node != null) {
					PlacesUtils.bookmarks.removeFolder(node);
				}
			}
			opmlFlag = false;
			response = doc;
			BMSVC.runInBatchMode(parseOMPLBatch, null);
			if (fireChangeID) {
				fireWizzEvent("changeid");
			}
		}
	} else if (text.substring(0, 2) == "KO") {
		alert(unescape(text.substring(2)));
	} else {
		alert(strbundle.getString("serverresperr"));
	}
}

XMLHttpRequest.prototype.Callback = null;

XMLHttpRequest.prototype.setCallback = function setCallback(callback) {
	XMLHttpRequest.prototype.Callback = callback;
}

XMLHttpRequest.prototype.getCallback = function getCallback() {
	return XMLHttpRequest.prototype.Callback;
}