var saveditemlist;

//**************************************************************************
function loadSavedItems() {
	document.getElementById("saveditems").setAttribute("style", "font-weight: normal;");
	saveditemlist = document.getElementById("saveditemlist");
	clearSavedItemList();
	readFolders();
}


//**************************************************************************
function readFolders() {
	try {
		var path = readPref("WizzRSSSavePath", fixpath(getWizzPath() + "wizzsaved"), 1);
		var dir = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		dir.initWithPath(path);
		var entries = dir.directoryEntries;
		while (entries.hasMoreElements()) {
			var file = entries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
			if (file.isDirectory()) {
				readFiles(file);
			}
		}
	} catch (e) {}
}


//**************************************************************************
function readFiles(dir) {
	var feedNameAdded = false;
	var entries = dir.directoryEntries;
	while (entries.hasMoreElements()) {
		var file = entries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
		if (!file.isDirectory()) {
			if (!feedNameAdded) {
				var title = saveditemlist.appendItem(dir.leafName, dir.path);
				title.setAttribute("style", "color: darkred; font-weight: bold;");
				feedNameAdded = true;
			}
			var newitem = saveditemlist.appendItem(file.leafName, file.path);
			newitem.setAttribute("class", "listitem-iconic");
			newitem.setAttribute("image", "chrome://wizzrss/skin/page.gif");
		}
	}
}


//**************************************************************************
function renderItem(event, value, label) {
	if (event.button != 2) {
		if (saveditemlist.selectedItem.getAttribute('class') != "") {
			var contentBrowser = getContentBrowser();
			if (event.button == 1 || (event.button == 0 && event.ctrlKey)) {
				var tab = contentBrowser.addTab("file:///" + value);
				if (readPref("WizzRSSFocusTab", false, 2)) {
					contentBrowser.selectedTab = tab;
				}
			} else {
				contentBrowser.loadURI("file:///" + value);
			}
		}
	}
}


//**************************************************************************
function clearSavedItemList() {
	var listcount = saveditemlist.getRowCount();
	while (listcount != 0) {
		listcount--;
		saveditemlist.removeItemAt(listcount);
	}
}


//**************************************************************************
function showDeletePopup(event) {
	event.preventDefault();
	if (saveditemlist.getRowCount() > 0) {
		if (saveditemlist.selectedIndex != -1) {
			document.popupNode = null;
			document.getElementById("deletesaveditems").showPopup(saveditemlist, event.screenX, event.screenY, "popup");
		}
	}
}


//**************************************************************************
function deleteSavedItem() {
	var msg = "";
	if (saveditemlist.selectedItem.getAttribute('class') == "") {
		msg = "Do you want to delete this folder and all of it's files?";
	} else {
		msg = "Do you want to delete this file?";
	}

	if (confirm(msg)) {
		var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(saveditemlist.selectedItem.value);
		if (file.exists()) {
			file.remove(true);
		}
		clearSavedItemList();
		readFolders();
	}
}
