var Cc = Components.classes;
var Ci = Components.interfaces;

var watchlistlist;

//**************************************************************************
function watchlistload() {
	watchlistlist = document.getElementById("watchlistlist");
	var mDBConn = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsINavHistoryService).QueryInterface(Ci.nsPIPlacesDatabase).DBConnection;
	var statement = mDBConn.createStatement("SELECT id, title, content FROM (SELECT id, title FROM moz_bookmarks WHERE id IN (SELECT moz_items_annos.item_id FROM moz_items_annos, moz_anno_attributes WHERE moz_items_annos.anno_attribute_id = moz_anno_attributes.id AND moz_anno_attributes.name = 'bookmarkProperties/feedwatched' AND moz_items_annos.content = 1)) AS a, (SELECT content, item_id FROM moz_items_annos, moz_anno_attributes WHERE anno_attribute_id = moz_anno_attributes.id AND moz_anno_attributes.name = 'bookmarkProperties/watchaction') AS b WHERE a.id = b.item_id");
	while (statement.executeStep()) {
		var listitem = document.createElement("listitem");
		var cell1 = document.createElement("listcell");
		cell1.setAttribute("label", statement.getString(1));
		cell1.setAttribute("value", statement.getInt32(0));
		listitem.appendChild(cell1);

		var cell2 = document.createElement("listitem");
		if (statement.getString(2) == "Find") {
			cell2.setAttribute("label", findstring);
		} else {
			cell2.setAttribute("label", savestring);
		}
		cell2.setAttribute("value", statement.getString(2));
		listitem.appendChild(cell2);
		watchlistlist.appendChild(listitem);
	}
	statement.reset();
	statement.finalize();
}

//**************************************************************************
function deleteItem() {
	var currentItem = watchlistlist.selectedItem;
	var nodeindex = currentItem.childNodes.item(0).getAttribute("value");
	opener.PlacesUtils.annotations.setItemAnnotation(nodeindex, "bookmarkProperties/feedwatched", false, 1, opener.PlacesUtils.annotations.EXPIRE_NEVER);
	watchlistlist.removeItemAt(watchlistlist.selectedIndex);
	if (watchlistlist.getRowCount() == 0) {
		opener.fireWizzEvent("stopwatch");
	}
}

//**************************************************************************
function deleteAll() {
	var listrowcount = watchlistlist.getRowCount();
	for (var n = 0; n < listrowcount; n++) {
		var currentItem = watchlistlist.getItemAtIndex(n);
		var nodeindex = currentItem.childNodes.item(0).getAttribute("value");
		opener.PlacesUtils.annotations.setItemAnnotation(nodeindex, "bookmarkProperties/feedwatched", false, 1, opener.PlacesUtils.annotations.EXPIRE_NEVER);
	}
	for (var n = 0; n < listrowcount; n++) {
		watchlistlist.removeItemAt(0);
	}
	opener.fireWizzEvent("stopwatch");
}

//**************************************************************************
function toggleAction() {
	var currentItem = watchlistlist.selectedItem;
	var nodeindex = currentItem.childNodes.item(0).getAttribute("value");
	var nodeaction = currentItem.childNodes.item(1).getAttribute("value");
	if (nodeaction == "Find") {
		currentItem.childNodes.item(1).label = savestring;
		currentItem.childNodes.item(1).value = "Save";
		opener.PlacesUtils.annotations.setItemAnnotation(nodeindex, "bookmarkProperties/watchaction", "Save", 3, opener.PlacesUtils.annotations.EXPIRE_NEVER);
	} else {
		currentItem.childNodes.item(1).label = findstring;
		currentItem.childNodes.item(1).value = "Find";
		opener.PlacesUtils.annotations.setItemAnnotation(nodeindex, "bookmarkProperties/watchaction", "Find", 3, opener.PlacesUtils.annotations.EXPIRE_NEVER);
	}	
}

//**************************************************************************
function toggleAll() {
	for (var n = 0; n < watchlistlist.getRowCount(); n++) {
		var currentItem = watchlistlist.getItemAtIndex(n);
		var nodeindex = currentItem.childNodes.item(0).getAttribute("value");
		var nodeaction = currentItem.childNodes.item(1).getAttribute("value");
		if (nodeaction == "Find") {
			currentItem.childNodes.item(1).label = savestring;
			currentItem.childNodes.item(1).value = "Save";
			opener.PlacesUtils.annotations.setItemAnnotation(nodeindex, "bookmarkProperties/watchaction", "Save", 3, opener.PlacesUtils.annotations.EXPIRE_NEVER);
		} else {
			currentItem.childNodes.item(1).label = findstring;
			currentItem.childNodes.item(1).value = "Find";
			opener.PlacesUtils.annotations.setItemAnnotation(nodeindex, "bookmarkProperties/watchaction", "Find", 3, opener.PlacesUtils.annotations.EXPIRE_NEVER);
		}
	}
}

//**************************************************************************
function doWatchListOK() {
	document.getElementById("watchlist").acceptDialog();
}

//**************************************************************************
function showManagePopup(event) {
	event.preventDefault();
	if (watchlistlist.currentIndex != -1) {
		document.getElementById("manage").showPopup(watchlistlist, event.screenX, event.screenY, "popup");
	}
}