function hidereadItems() {
	writePref("WizzRSSShowWLRead", false, 2);
	restoreViewList();
}

//**************************************************************************
function showreadItems() {
	writePref("WizzRSSShowWLRead", true, 2);
	restoreViewList();
}

//**************************************************************************
function loadViewItems(filterFlag, filterString) {

	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	os.notifyObservers(this, "wlnotify", "off");
	document.getElementById("founditems").setAttribute("style", "font-weight: normal;");
	clearViewItemList();

	itemlist = viewitemlist;
	itemdesc = viewitemdesc;

	var sqlstring = "SELECT bookmarkid, itemtitle, itemurl, enclosureurl, itemsummary, itemcontent, itemdate FROM wlaggregated";

	if (filterFlag) {
		var filter = filterString.split(" ");
		for (var n = 0; n < filter.length; n++) {
			if (n == 0) {
				sqlstring += " WHERE ";
			} else {
				sqlstring += " OR ";
			}
			var critstring = filter[n];
			critstring = critstring.replace(/&/g, ' ');
			sqlstring += " itemtitle LIKE '%" + critstring + "%' OR itemsummary LIKE '%" + critstring + "%'";
		}
	}

	if (readPref("WizzRSSSortItems", false, 2)) {
		if (readPref("WizzRSSSortedBy", "Alpha", 1) == "Alpha") {
			sqlstring += " ORDER BY bookmarkid, itemtitle";
		} else {
			sqlstring += " ORDER BY bookmarkid, itemdate DESC";
		}
	} else {
		sqlstring += " ORDER BY bookmarkid, recid";
	}

	renderItems(sqlstring, filterFlag);
}

//**************************************************************************
function renderItems(sqlstring, filterFlag) {

	var showReadItems = readPref("WizzRSSShowWLRead", false, 2);
	var useContent = readPref("WizzRSSUseContent", false, 2);
	var nodescription = strbundle.getString("nodescription");
	var retaintime = readPref("WizzRSSRetainDays", 14, 3);
	if (retaintime == 0) {
		retaintime = 1;
	}
	retaintime = retaintime * 86400000;
	retaintime = new Date().getTime() - retaintime;

	var newitem;
	var readicon = "chrome://wizzrss/skin/" + readPref("WizzRSSReadDot", "Red", 1) + ".gif";
	var itemHistFlag;
	var encHistFlag;
	var bookmarkID = 0;
	var foundflag = false;

	var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	file.append("wizzrss");
	file.append("wizzrss.sqlite");
	var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	var mDBConn = storageService.openDatabase(file);
	mDBConn.executeSimpleSQL("DELETE FROM wlaggregated WHERE addeddate < " + retaintime);

	var statement = mDBConn.createStatement(sqlstring);
	while (statement.executeStep()) {
		foundflag = true;
		var bmid = statement.getInt32(0);

		if (bmid != bookmarkID) {
			bookmarkID = bmid;
			var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
			var titleText = bmsvc.getItemTitle(bookmarkID);
			var titleSummary = PlacesUtils.annotations.getItemAnnotation(bookmarkID, "bookmarkProperties/description");
			var feedlink = PlacesUtils.annotations.getItemAnnotation(bookmarkID, "bookmarkProperties/feedhome");
			var title = viewitemlist.appendItem(titleText, "Title-;-" + titleSummary + "-;-" + feedlink);
			title.setAttribute("style", "color: darkred; font-weight: bold;");
				
		}
		var itemTitle = statement.getString(1);
		var itemURL = statement.getString(2).replace(/&amp;/g, "&");
		var enclosureURL = statement.getString(3).replace(/&amp;/g, "&");
		var itemSummary = statement.getString(4);
		var itemContent = statement.getString(5);
		var itemDate = new Date(statement.getInt64(6)).toUTCString();
		itemHistFlag = wizzHistory.checkHist(itemURL);
		encHistFlag = wizzHistory.checkHist(enclosureURL);

		if (((!showReadItems && !itemHistFlag) || showReadItems) || ((!showReadItems && !encHistFlag) || showReadItems)) {

			var itemText = "";

			if (useContent && itemContent.length > 0) {
				itemText = itemContent;
			} else {
				if (itemSummary.length > 0) {
					itemText = itemSummary;
				} else {
					itemText = nodescription;
				}
			}
			newitem = viewitemlist.appendItem(itemTitle, itemURL + "-;-" + itemText + "-;-" + enclosureURL + "-;-" + itemDate);
			newitem.setAttribute("class", "listitem-iconic");
			if (enclosureURL == "") {
				if (itemHistFlag) {
					newitem.setAttribute("image", readicon);
				} else {
					newitem.setAttribute("image", "chrome://wizzrss/skin/Unread.gif");
				}
			} else {
				newitem.style.fontStyle = "italic";
				if (itemHistFlag && encHistFlag) {
					newitem.setAttribute("image", readicon);
				} else if (!itemHistFlag && !encHistFlag) {
					newitem.setAttribute("image", "chrome://wizzrss/skin/Unread.gif");
				} else {
					newitem.setAttribute("image", "chrome://wizzrss/skin/PartRead.gif");
				}
			}
		}
	}
	statement.reset();
	statement.finalize();
	mDBConn.close();
	if (filterFlag && !foundflag) {
		alert(strbundle.getString("filternotfound"));
		restoreViewList();
	}
}

//**************************************************************************
function clearCache() {
	var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	file.append("wizzrss");
	file.append("wizzrss.sqlite");
	var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	var mDBConn = storageService.openDatabase(file);
	mDBConn.executeSimpleSQL("DELETE FROM wlaggregated");
	clearViewItemList();
	if (!readPref("WizzRSSHideDesc", false, 2)) {
		itemdesc.contentDocument.getElementById("divid").innerHTML="";
	}
}

//**************************************************************************
function clearViewItemList() {
	var listcount = viewitemlist.getRowCount();
	viewitemlist.scrollToIndex(0);
	while (listcount != 0) {
		listcount--;
		viewitemlist.removeItemAt(listcount);
	}
}

//**************************************************************************
function showViewMarkPopup(event) {
	event.preventDefault();
	if (viewitemlist.getRowCount() > 0 && viewitemlist.selectedIndex != -1) {
		var values = viewitemlist.selectedItem.value.split("-;-");
		if (values[0] == "Title") {
			//document.getElementById("markitemfi").setAttribute("disabled", "true");
			//document.getElementById("unmarkitemfi").setAttribute("disabled", "true");
			document.getElementById("itememailfi").setAttribute("disabled", "true");
			document.getElementById("newtabfi").setAttribute("disabled", "true");
		} else {
			//document.getElementById("markitemfi").setAttribute("disabled", "false");
			//document.getElementById("unmarkitemfi").setAttribute("disabled", "false");
			document.getElementById("itememailfi").setAttribute("disabled", "false");
			document.getElementById("newtabfi").setAttribute("disabled", "false");
		}
		document.popupNode = null;
		document.getElementById("markviewitems").showPopup(viewitemlist, event.screenX, event.screenY, "popup");
	}
}

//**************************************************************************
function smtpViewStuff(val) {
	if (val == 2) {
		opener.smtpStuff(2, viewitemdesc.contentDocument.getElementById("Title").innerHTML + "-;-" + viewitemdesc.contentDocument.getElementById("URL").value + "-;-" + viewitemdesc.contentDocument.getElementById("Text").innerHTML, null);
	} else {
		var values = viewitemlist.selectedItem.value.split("-;-");
		if (values.length > 1) {
			var item = viewitemlist.selectedItem;
			opener.smtpStuff(2, item.label + "-;-" + item.value, null);
		}
	}
}

//**************************************************************************
function restoreViewList() {
	clearViewItemList();
	loadViewItems(false, null);
}

//**************************************************************************
function filterViewList() {
	var val = prompt(strbundle.getString("filtertext"), readPref("WizzRSSLastFilter", "", 1), strbundle.getString("filtertitle"));
	if (val != null && val.length != 0) {
		val = trim(val);
	}
	if (val != null && val.length != 0) {
		writePref("WizzRSSLastFilter", val, 1);
		clearViewItemList();
		loadViewItems(true, val);
	}
}
