var weatherCountry;
var weatherLocation;

//**************************************************************************
function weatherload() {
	opener.addEventListener("close", doWeatherOK, true);
	weatherCountry = opener.readPref("WizzRSSWeatherCountry", "", 1);
	weatherLocation = opener.readPref("WizzRSSWeatherLocation", "", 1);

	var retval = opener.readFile(opener.fixpath(opener.getWizzPath() + "wizzrss") + "country.txt");
	if (retval == null) {
		var xmlReq = new XMLHttpRequest();
		xmlReq.open("GET", "http://www.wizzrss.com/wizzrss2/GetCountry.php", true);
		xmlReq.onerror = weatherError;
		xmlReq.onload = countryListOnLoad;
		xmlReq.send(null);
	} else {
		popCountry(retval);
	}
}

//**************************************************************************
function weatherunload() {
	opener.removeEventListener("close", doWeatherOK, true);
	var currentCountry = document.getElementById("countrylist").label;
	var currentLocation = document.getElementById("locationlist").label;
	if (currentCountry != "") {
		opener.writePref("WizzRSSWeatherCountry", currentCountry, 1);
	}
	if (currentLocation != "") {
		opener.writePref("WizzRSSWeatherLocation", document.getElementById("locationlist").label, 1);
	}
}

//**************************************************************************
function countryListOnLoad(event) {
	var text = event.target.responseText;
	text = text.replace(/\\'/g, "'");
	if (text.substring(0, 2) == "OK") {
		opener.writeFile(text, opener.fixpath(opener.getWizzPath() + "wizzrss") + "country.txt");
		popCountry(text);
	} else {
		displayMsg(text);
	}
}

//**************************************************************************
function popCountry(text) {
	var countrylist = document.getElementById("countrylist");
	var countries = text.substring(2).split(";");
	for (var i = 0; countries.length - 1 > i; i++) {
		countrylist.appendItem(countries[i]);
		if (countries[i] == weatherCountry) {
			countrylist.setAttribute("label", countries[i]);
		}
	}
	if (countrylist.label == "") {
		countrylist.setAttribute("label", countries[0]);
	}
	locationList();
}

//**************************************************************************
function locationList() {
	var countrylist = document.getElementById("countrylist");
	var retval = opener.readFile(opener.fixpath(opener.getWizzPath() + "wizzrss") + fixName(countrylist.label) + ".txt");
	if (retval == null) {
		var xmlReq = new XMLHttpRequest();
		xmlReq.open("GET", "http://www.wizzrss.com/wizzrss2/GetLocation.php?countryname=" + countrylist.label.replace(/'/g, "\\'"), true);
		xmlReq.onerror = weatherError;
		xmlReq.onload = locationListOnLoad;
		xmlReq.send(null);
	} else {
		popLocation(retval);
	}
}

//**************************************************************************
function locationListOnLoad(event) {
	var text = event.target.responseText;
	text = text.replace(/\\'/g, "'");
	if (text.substring(0, 2) == "OK") {
		var countrylist = document.getElementById("countrylist");
		opener.writeFile(text, opener.fixpath(opener.getWizzPath() + "wizzrss") + fixName(countrylist.label) + ".txt");
		popLocation(text);
	} else {
		displayMsg(text);
	}
}

//**************************************************************************
function popLocation(text) {
	var detail;
	var found = false;
	var locationlist = document.getElementById("locationlist");
	locationlist.removeAllItems();
	var locations = text.substring(2).split(";");
	for (var i = 0; locations.length - 1 > i; i++) {
		detail = locations[i].split(":");
		locationlist.appendItem(detail[0], detail[1]);
		if (detail[0] == weatherLocation) {
			found = true;
			locationlist.setAttribute("label", detail[0]);
			locationlist.setAttribute("value", detail[1]);
		}
	}
	if (!found) {
		detail = locations[0].split(":");
		locationlist.setAttribute("label", detail[0]);
		locationlist.setAttribute("value", detail[1]);
	}
	getMetar();
}
	
//**************************************************************************
function getMetar() {
	var locationlist = document.getElementById("locationlist");
	var language = document.getElementById("language");
	var xmlReq = new XMLHttpRequest();
	xmlReq.open("GET", "http://www.wizzrss.com/phpweather/GetNewText.php?icao=" + locationlist.value + "&lang=" + language.value, true);
	xmlReq.onerror = weatherError;
	xmlReq.onload = getMetarOnLoad;
	xmlReq.send(null);
}

//**************************************************************************
function getMetarOnLoad(event) {
	var text = event.target.responseText;
	if (text.substring(0, 2) == "OK") {
		var weatherdetail = document.getElementById("weatherdetail");
		var el = weatherdetail.contentDocument.getElementById("divid");
		el.innerHTML = text.substring(2).replace(/\\'/, "'");
	} else {
		displayMsg(text);
	}
}

//**************************************************************************
function weatherError(event) {
	try {
		displayMsg(opener.strbundle.getString("weatherErrorText"));
	} catch (e) {}
}

//**************************************************************************
function displayMsg(text) {
	var weatherdetail = document.getElementById("weatherdetail");
	var el = weatherdetail.contentDocument.getElementById("divid");
	el.innerHTML = text;
}

//**************************************************************************
function fixName(text) {
	text = text.replace(/ /g, "_");
	if (text.length > 15) {
		text = text.substring(0, 15);
	}
	return text;
}

//**************************************************************************
function doWeatherOK() {
	document.getElementById("weather").acceptDialog();
}